###############################
#Differential Equation Model
#################################
formED<-function(t,y,p)
{

	CLD<-p[1]
	V1<-p[2]
	V2<-p[3]
	CL<-p[4]
	FM<-p[5]
	RM<-p[6]
	FG1<-p[7]
	RG1<-p[8]
	TInf<-0.1666
	R<-(50)/TInf
	

	if (t<=TInf) yd1<--CLD/V1*y[1]+CLD/V2*y[2]-CL/V1*y[1]+R
	else yd1<--CLD/V1*y[1]+CLD/V2*y[2]-CL/V1*y[1]		
	yd2<-CLD/V1*y[1]-CLD/V2*y[2]
	yd3<-FG1*CL/V1*y[1]-y[3]*RG1
	yd4<-FM*CL/V1*y[1]-RM*y[4]
	
	list(c(yd1,yd2,yd3,yd4),c(y[2]/V1,y[3]/5.92,y[4]/5.92))
}

