#PFIM 3.0 Multiple responses
#Avril 2008
#Copyright  PFIM 3.0  Caroline Bazzoli, Sylvie Retout, Emmanuelle Comets, France Mentr - Universit Paris Diderot  INSERM.
#-----------------------------------------------------------------------------------


under.unix<-!(version$os=='Microsoft Windows' ||
      version$os=='Win32' || version$os=='mingw32')
dirsep<-ifelse(under.unix,"/","\\")

library(nlme)
library(odesolve)
options(expressions=1000)
subjects<-NULL

directory<-"C:\\Documents and Settings\\U7385\\Mes documents\\caroline\\PFIM3.0\\PFIM3.0"
directory.program<-"C:\\Documents and Settings\\U7385\\Mes documents\\caroline\\PFIM3.0\\PFIM3.0\\Program"

PFIM<-function(model.file="Stdin.r") {		      
   under.unix<-!(version$os=='Microsoft Windows' ||
      version$os=='Win32' || version$os=='mingw32')
   dirsep<-ifelse(under.unix,"/","\\")
   cat("Directory for PFIM3.0 programs:",directory.program,"\n")
   cat("Directory for project:",directory,"\n")
   source(paste(directory,dirsep,model.file,sep=""))
   source(paste(directory,dirsep,file.model,sep=""))

#source(paste(directory,"\\",file.model,sep="")) 
#inutile pour le FW donc rentr dans les autres boucles
     if (run=="EVAL"){
        source(paste(directory,file.model,sep=dirsep))
        if (modelform=="DE")
           source(paste(directory.program,dirsep,"EQPfim3.0op1.simu.r",sep=""))
        else
            source(paste(directory.program,dirsep,"Pfim3.0op1.simu.r",sep=""))
        out()
     } else { # run=="OPT"
  
        if (algo.option=="FW") {
#            source(paste(directory.program,dirsep,"algofedorov.simu.r",sep=""))
#provisoire : pour l'instant je source rcostfed.pr, mais il devrait tre renomm
# version normale de fedorov rdosefed.pr ( renommer en algofedorov.r par ex)
            source(paste(directory.program,"\\algofedorov.simu.r",sep=""))
            out.fedorov(modelfile=model.file,directory=directory,
               directory.program=directory.program)
        } else {
            if (modelform=="DE")
              source(paste(directory.program,dirsep,"EQPfimOPT3.0op1.simu.r",sep=""))
            else 
              source(paste(directory.program,dirsep,"PfimOPT3.0op1.simu.r",sep=""))
              
            if (algo.option=="SIMP") {
               source(paste(directory,file.model,sep=dirsep))
               source(paste(directory.program,dirsep,"algosimplex.simu.r",sep=""))
               x<-out.simplex()
		           print(x)
               remove(subjects,inherits = FALSE)
            } else 
	       cat("Error in the specification of the optimisation algorithm.","\n")
        }
     }
}
