#PFIM 3.0 Multiple responses
#Avril 2008
#Copyright  PFIM 3.0  Caroline Bazzoli, Sylvie Retout, Emmanuelle Comets, France Mentr - Universit Paris Diderot  INSERM.
#-----------------------------------------------------------------------------------
###########################################################################
# 	Computation of the Population Fisher Information matrix       	 	  #     
#	 							 									 #							     
###########################################################################


#---------------------- PRE - COMPUTATION ------------------------------------
#-----------------------------------------------------------------------------


theta<-beta
#lf<-length(form)
p<-length(theta)

#ld<-length(protPD)                   #meme nombre de protocoles elementaires
#prots<-list(prot,protPD)

prots<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("prot",LETTERS[1:nr],sep=""))
sigmainter<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("sig.inter",LETTERS[1:nr],sep=""))
sigmaslope<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("sig.slope",LETTERS[1:nr],sep=""))
#bornes<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("borne",LETTERS[1:nr],sep=""))

erro<-tryCatch(graphinf<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("graph.inf",LETTERS[1:nr],sep="")),error=function(e) 1)          
#e=0 si pas d'erreur et 1 sinon#
if (length(which(unlist(erro)==1))>=1)
{
vecg<-replicate(nr,0)
graphinf<- as.vector(vecg,mode="list")
graphsup<-lapply(1:nr,function(nr,x) max(unlist(get(x[nr]))),x=paste("prot",LETTERS[1:nr],sep=""))
} else
{
graphinf<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("graph.inf",LETTERS[1:nr],sep=""))
graphsup<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("graph.sup",LETTERS[1:nr],sep=""))
}

#scal<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("scale",LETTERS[1:nr],sep=""))
lp<-length(prots[[1]])

if (condinit.identical==T) condinit<-rep(condinit[1],lp) else NULL

#-----------------------------------------------------------------------------
#------------------------ COMPUTE --------------------------------------------


#Function used in Population Fisher information matrix  function 
#------------------------------------
pts<-function(nr,i,prots){
protk<-c()
lprotk<-c()
for (k in 1:nr){
protk <-c(protk,prots[[k]][i])  
#lprotk<-c(protk,prots[[k]][i])
}
return(protk)
}

#Function used in sensibilite function
#------------------------------------

inter<-function(theta,k,t,l)
{
	
	for (i in 1:p) {assign(parameters[i],theta[i]) }
	cond<-eval(condinit[k])
  #res<-lsoda(cond,times=c(time.condinit,theta[p+1]),formED,theta,rtol=RtolEQ,atol=AtolEQ,hmax=Hmax)[,cmpt.of.interest[t]+1][2]/eval(quote(V))
  res<-lsoda(cond,times=c(time.condinit,theta[p+1]),formED,theta,rtol=RtolEQ,atol=AtolEQ,hmax=Hmax)
  if (nr==1)res<-res[,dim(res)[2]][2]
  else res<-res[,((dim(res)[2]-nr+1):(dim(res)[2]))][,l] [-1]
}


#Sensitivity matrix :
#--------------------
sensibilite<-function(nr,protk,k,lprotk)
{	

	#lpi<-length(proti)
  #lpd<-length(protiPD) 
	for (i in 1:p) {assign(parameters[i],theta[i]) }
	mod<-list()
	dd<-list()
	s<-list()
	s1<-matrix(nrow=p,ncol=0)
	cond<-eval(condinit[k])	
	#lapply(1:nr,function(nr,cond,time.condinit,prots,formED,theta) lsoda(cond,c(time.condinit,prots[[nr]][[k]]),formED,theta,rtol=RtolEQ,atol=AtolEQ,hmax=Hmax)[,cmpt.of.interest[1]+1][-1]/eval(scal[[nr]]),cond=cond,formED=formED,prots=prots,theta=theta,time.condinit=time.condinit)
	for (l in 1:nr){
	if (lprotk[[l]]==0){
	s<-matrix(nrow=p,ncol=0)} else
  {	
  #print(l)
	#print(protk[[l]])
  #mod[[l]]<-lsoda(cond,c(time.condinit,protk[[l]]),formED,theta,rtol=RtolEQ,atol=AtolEQ,hmax=Hmax)[,cmpt.of.interest[l]+1][-1]/eval(scal[[l]])
  mod[[l]]<-lsoda(cond,c(time.condinit,protk[[l]]),formED,theta,rtol=RtolEQ,atol=AtolEQ,hmax=Hmax)
  if (nr==1) mod[[l]]<-mod[[l]][,dim(mod[[l]])[2]][-1]      #single response
  else mod[[l]]<-mod[[l]][,((dim(mod[[l]])[2]-nr+1):(dim(mod[[l]])[2]))][,l][-1]
  #print(mod[[l]])
  lfd<-lprotk[[l]]
  #sc<-scal[[l]]
  #dd[[l]]<-lapply(1:lfd,fun ction(lfd,theta,protk,k,t,scal,l) fdHess(c(theta,protk[lfd]),inter,k=k,scal=scal,t=l,l=l)$gradient,theta=theta,protk=protk[[l]],k=k,scal=scal,l=l)
  dd[[l]]<-lapply(1:lfd,function(lfd,theta,protk,k,t,l) fdHess(c(theta,protk[lfd]),inter,k=k,t=l,l=l)$gradient,theta=theta,protk=protk[[l]],k=k,l=l)
  #print(dd[[l]])
  s<-t(matrix(unlist(dd[[l]]),ncol=lprotk[[l]]))[,1:p]
   
  if(lprotk[[l]]==1) s<-matrix(s,nrow=p,ncol=1) else s<-t(s)
  }
  
  if (Trand==2) {
  s<-s*theta
	#s1<-s1*theta
  }
  s1<-cbind(s1,s)
  #s<-t(s)
   #s1<-t(t(matrix(unlist(dd1[[l]]),ncol=lprotk[[l]]))[,1:p])
  }
  
  #mod1<-lsoda(cond,c(time.condinit,protiPD),formED,theta,rtol=RtolEQ,atol=AtolEQ,hmax=Hmax)[,cmpt.of.interest[2]+1][-1]
  #dd<-lapply(1:lpi,function(lpi,theta,proti,k) fdHess(c(theta,proti[lpi]),inter,k=k,scale=scale,t=1)$gradient,theta=theta,proti=proti,k=k)
  #dd1<-lapply(1:lpd,function(lpd,theta,protiPD,k) fdHess(c(theta,protiPD[lpd]),inter,k=k,scale=1,t=2)$gradient,theta=theta,protiPD=protiPD,k=k)
 
	
	 
	#s1<-t(s1)
	
	#if (Trand==2) {
  #s<-s*theta
	#s1<-s1*theta
  #}
	l1<-list(unlist(mod),s1)
	#print(l)
	return(l1) 
}


# Fisher matrix for 1 ind in 1 elementary design by block: block A (resA), block B(resB), block C (resC)
#-------------------------------------------------------------------------------------------------------
bloc<-function(protk,sensi,var,invvar,dvar,mod,lprotk,bout4)   #proti,protiPD,sensi,var,invvar,dvar,mod

{
  #c<-length(proti) 
	#c1<-length(protiPD)
	resB<-matrix(nrow=p+nr*2,ncol=p+nr*2)     #matrice alatoire #
	resC<-matrix(rep(0,(p+nr*2)*p),nrow=p+nr*2,ncol=p)     #matrice incomplete option 1 covariance==0#

	if (Trand==2) sensia<-sensi/theta 	else sensia<-sensi 
	
	resA1<-(sensia %*% invvar) %*% t(sensia)  #matrice parametres fixe#
	
	#sigma inter PK#
	#a1<-2*diag(c(sig.inter+sig.slope*mod[1:c],rep(0,length(protiPD))),length(c(proti,protiPD)))
	#a3<-invvar%*%a1%*%invvar
	#resB[p+1,p+1]<-sum(diag(a3%*%a1))
	#sigma slope PK#
	#a2<-a1*mod
	#print(a2)
  #resB[p+2,p+2]<-sum(diag(a2%*%invvar%*%a2%*%invvar))
  #print(resB[p+2,p+2])
	#sigma inter PK et sigma slope PK#
	#resB[p+1,p+2]<-sum(diag(a3%*%a2))
	#resB[p+2,p+1]<-resB[p+1,p+2]
	
	l1<-list()
	li<-list()
	l2<-list()
	#premiere rponse
	c<-cumsum(unlist(lprotk))
	long<-c[nr]-c[1]
  a1<-2*diag(c(bout4[[1]],rep(0,long)),length(unlist(protk)))
	ai<-invvar%*%a1%*%invvar
	resB[p+1,p+1]<-sum(diag(ai%*%a1))
	a2<-a1*mod
	resB[p+2,p+2]<-sum(diag(a2%*%invvar%*%a2%*%invvar))
	resB[p+1,p+2]<-sum(diag(ai%*%a2))
	resB[p+2,p+1]<-resB[p+1,p+2]
	l1[[1]]<-a1
	li[[1]]<-ai
	l2[[1]]<-a2
	
	if (nr!=1){
	for (i in 1:(nr-1)){
	long<-c[i]
  vec<-rep(0,length(unlist(protk)))
  #if(length(bout4)==nr){
  if(length(protk[[i+1]])!=0){
  vec[long+1:(lprotk[[i+1]])]=bout4[[i+1]]
  }else{
  vec<-vec
  } 
   #for each response
	#a1<-2*diag(c(sig.inter+sig.slope*mod[1:c],rep(0,length(protiPD))),length(c(proti,protiPD)))
	#a1<-2*diag(c(rep(0,long)),bout4[i+1]),length(unlist(protk)))
	a1<-2*diag(vec,length(unlist(protk)))
	#a3<-invvar%*%a1%*%invvar
	ai<-invvar%*%a1%*%invvar
	#sigma inter
	#resB[p+1,p+1]<-sum(diag(a3%*%a1))
	resB[p+i*2+1,p+i*2+1]<-sum(diag(ai%*%a1))
	#sigma slope #
	a2<-a1*mod
	#print(a2)
	#resB[p+2,p+2]<-sum(diag(a2%*%invvar%*%a2%*%invvar))
  resB[p+i*2+2,p+i*2+2]<-sum(diag(a2%*%invvar%*%a2%*%invvar))
  #print(resB[p+2,p+2])
  
	#sigma inter  et sigma slope 
	#resB[p+1,p+2]<-sum(diag(a3%*%a2))
	#resB[p+2,p+1]<-resB[p+1,p+2]
	resB[p+(i*2)+1,p+i*2+2]<-sum(diag(ai%*%a2))
	resB[p+i*2+2,p+(i*2)+1]<-resB[p+(i*2)+1,p+i*2+2]
	l1[[i+1]]<-a1
	li[[i+1]]<-ai
	l2[[i+1]]<-a2
  }
 
  
	#sigma inter PD#
	#a4<-2*diag(c(rep(0,length(proti)),sig.interPD+sig.slopePD*mod[(c+1):(c+c1)]),length(c(proti,protiPD)))
	#a4b<-invvar%*%a4%*%invvar
  #resB[p+3,p+3]<-sum(diag(a4b%*%a4))
  #sigma slope PD#
  #a5<-a4*mod
	#resB[p+4,p+4]<-sum(diag(a5%*%invvar%*%a5%*%invvar))
  #sigma slope PD et sigma inter PD#
	#resB[p+4,p+3]<-sum(diag(a4b%*%a5))  resB[p+3,p+4]<-resB[p+4,p+3]
	
  #sigma inter PD et sigma inter PK#
  for (i in 1: (nr)){
    for (j in  2 : (nr)){
	#resB[p+3,p+1]<-sum(diag(a4b%*%a1))  resB[p+1,p+3]<-resB[p+3,p+1]    #ai[2]*a1
	#resB[p+3,p+1]<-sum(diag(li[2]%*%l1[1]))  resB[p+1,p+3]<-resB[p+3,p+1]
	     resB[(p+j*2-1),p+i*2-1]<-sum(diag(li[[j]]%*%l1[[i]])) 
       resB[p+i*2-1,(p+j*2-1)]<-resB[(p+j*2-1),p+i*2-1] #resB[p+1,p+3]<-resB[p+3,p+1]
	#sigma slope PD et sigma inter PK#
	#resB[p+4,p+1]<-sum(diag(li[1]%*%l2[2])) 	resB[p+1,p+4]<-resB[p+4,p+1]
	     resB[p+j*2,p+i*2-1]<-sum(diag(li[[i]]%*%l2[[j]])) 	#resB[p+1,p+4]<-resB[p+4,p+1]
       resB[p+i*2-1,p+j*2]<-resB[p+j*2,p+i*2-1]
	#sigma inter PD et sigma slope PK#
	#resB[p+3,p+2]<-sum(diag(li[2]%*%l2[1]))  resB[p+2,p+3]<-resB[p+3,p+2]
	     resB[p+j*2-1,p+i*2]<-sum(diag(li[[j]]%*%l2[[i]]))  #resB[p+2,p+3]<-resB[p+3,p+2]
	     resB[p+i*2,p+j*2-1]<-resB[p+j*2-1,p+i*2]
	#sigma slope PD et sigma slope PK#
	#resB[p+4,p+2]<-sum(diag(invvar%*%l2[2]%*%invvar%*%l2[1])) resB[p+2,p+4]<-resB[p+4,p+2]
	     resB[p+j*2,p+i*2]<-sum(diag(invvar%*%l2[[j]]%*%invvar%*%l2[[i]]))
       resB[p+i*2,p+j*2]<-resB[p+j*2,p+i*2] #resB[p+2,p+4]<-resB[p+4,p+2]
	}
	}
	
	for (i in 1:p)
	{
		resB1<-sensi[i,]%*%t(sensi[i,])
		resB2<-invvar%*%resB1%*%invvar
		resB[i,1:p]<-sapply(1:p,function(resB2,sensi,p) sum(diag(resB2%*%sensi[p,]%*%t(sensi[p,]))),resB2=resB2,sensi=sensi)
		resB[i,p+1]<-sum(diag(l1[[1]]%*%resB2))
		resB[i,p+2]<-sum(diag(l2[[1]]%*%resB2))

    for ( j in 2:nr) {
    
		resB[i,p+j*2-1]<-sum(diag(l1[[j]]%*%resB2))
		resB[i,p+j*2]<-sum(diag(l2[[j]]%*%resB2)) 	
	 }
  resB[(p+1):(p+(2*nr)),i]<-resB[i,(p+1):(p+(2*nr))]
  }
  } else {
  
   for (i in 1:p)
	{
		resB1<-sensi[i,]%*%t(sensi[i,])
		resB2<-invvar%*%resB1%*%invvar
		resB[i,1:p]<-sapply(1:p,function(resB2,sensi,p) sum(diag(resB2%*%sensi[p,]%*%t(sensi[p,]))),resB2=resB2,sensi=sensi)
		resB[i,p+1]<-sum(diag(l1[[1]]%*%resB2))
		resB[i,p+2]<-sum(diag(l2[[1]]%*%resB2))
		resB[(p+1):(p+2),i]<-resB[i,(p+1):(p+2)]	
	}
  }
  
  
	resB<-0.5*resB 
	#print(resB)
	h<-cbind(rbind(resA1,resC),rbind(t(resC),resB))
	#print(h)
	return(h) 
}

#Population Fisher information matrix
#------------------------------------
fisher<-function()
{	 
	pp<-2*p+2*nr #2 parameters for the residual variance by response#
	somme<-matrix(c(rep(0,pp*pp)),ncol=pp) 
	se<-numeric() 
	cv<-numeric() 
	
	for(i in 1: length(prots[[1]]))  #pour chaque protocole meme nombre de protocole elementaire en pk et pd#
	{
	    protk<-pts(nr,i,prots)
	    #print(protk)
	    lprotk<-lapply(1:nr,function(nr,protk) length(protk[[nr]]),protk=protk )
      #protk<-lapply(1:nr,function(nr,i,prots) pts(nr,i,prots[[nr]]),prots=prots,i=i)
      #lprotk<-lapply(1:nr,function(nr,protk) length(protk[[nr]][[1]]),protk=protk )
			#c<-length(proti) 
	    #c1<-length(protiPD)
	    #sensibili<-lapply(1:nr, function(nr,protk,i) sensibilite(protk,i),protk=protk,i=i))
			sensibili<-sensibilite(nr,protk,i,lprotk)  #i the elementar protocol
			#print(sensibili)
			mod<-sensibili[[1]] 
			sensi<-sensibili[[2]] 
			bout1<-omega%*%sensi
			#print(bout1)
			bout4<-list()
			t1<-0
			t<-0
			for (n in 1:(nr)){
			t<-1+t1
			t1<-t-1+lprotk[[n]]
			if(lprotk[[n]]==0){
			bout4[[n]]<-NULL 
      if(n==nr){bout4[[n+1]]=Inf}
      } else {
			bout3<-sigmainter[[n]]+sigmaslope[[n]]*mod[t:t1]
			bout4[[n]]<-bout3
			}
			}
			t<-NULL
			t1<-NULL
      #bout3<-list(bout3,sigmainter+sigmaslope*mod[1:c]
      #modele PK#
			#print(bout3)
			#bout4<-sig.interPD+sig.slopePD*mod[(c+1):(c+c1)] #modele PD#
			#print(bout4)
			#print(diag(c(bout3^2,bout4^2),length(c(proti,protiPD))))
			var<-t(bout1) %*% sensi + diag(unlist(bout4[1:nr])^2,length(unlist(protk))) 
			#print(var)
			invvar<-solve(as.matrix(var)) 
      #print(invvar)
			#fish<-bloc(proti,protiPD,sensi,var,invvar,dvar,mod)
      fish<-bloc(protk,sensi,var,invvar,dvar,mod,lprotk,bout4) 
			#print(fish)
			somme<-somme+subjects[i]*fish 
      #print(somme)	
		}
	
	
	#SIG<<-c(sig.inter,sig.slope,sig.interPD,sig.slopePD)
	sigmaslopen<-lapply(1:nr,function(nr,x) x[nr],x=paste("sig.slope",LETTERS[1:nr],sep=""))
  sigmaintern<-lapply(1:nr,function(nr,x) x[nr],x=paste("sig.inter",LETTERS[1:nr],sep=""))
  xn<-rbind(sigmaintern,sigmaslopen)
  xv<-rbind(sigmainter,sigmaslope)
  SIG<<-unlist(c(xv))
  SIGN<<-unlist(c(xn))
	vec2<<-SIG!=0
	SIG<<-SIG[vec2]	
	SIGN<-SIGN[vec2]
	lSIG<<-length(SIG)	
	
	vec<<-diag(omega)!=0 
	omega1<<-as.matrix(omega[,vec])[vec,] 
	vec<-c(rep(T,p),vec,vec2) 
 		#remove the row i and the col i of somme if omega[i,i]=0  
	somme<-somme[,vec][vec,] 
	pp<-dim(somme)[1] 		    
	det<-det(somme)	
	inv<-try(solve(as.matrix(somme))) 
	if(!is.null(attributes(inv)$class))
	 {
		se<-rep(NA,pp)
		cv<-se	
		crit<-(det)^(1/pp) 
		} else
     {
		se<-sqrt(diag(inv)) 
		cv1<-se[1:p]/theta*100 
		cv2<-se[(p+1):(pp-lSIG)]/diag(omega1)*100 
		cv3<-se[(pp-(lSIG-1)):pp]/SIG*100 
		cv<-abs(c(cv1,cv2,cv3))	
		crit<-(det)^(1/pp) 
	}
	
return(formED,somme,subjects,prots,se,cv,det,crit,p,pp,xn,sensibili) 

}


graph<-function(prots,graphinf,graphsup)
{
		for (i in 1:p) {assign(parameters[i],theta[i]) }
		tt<-list()
		ff1<-list
    e<-list()
    e1<-list()
    tt<-lapply(1:nr, function(nr,graphinf,graphsup) seq(graphinf[[nr]],graphsup[[nr]],0.1),graphinf=graphinf,graphsup=graphsup)
	
		
		if (condinit.identical==T)
		{
				par(mfrow=c(1,nr))
				cond<-eval(condinit[1])
			  #ff1<-lsoda(cond,c(time.condinit,tt),formED,theta,rtol=RtolEQ,atol=AtolEQ,hmax=Hmax)[,cmpt.of.interest[1]+1][-1]/eval(scal)
        e<-lapply(1:nr,function(nr,time.condinit,tt) c(time.condinit,tt[[nr]]),time.condinit=time.condinit,tt=tt)
        #ff1<-lapply(1:nr,function(nr,cond,e,formED,theta,scal) lsoda(cond,e[[nr]],formED,theta,rtol=RtolEQ,atol=AtolEQ,hmax=Hmax)[,cmpt.of.interest[nr]+1][-1]/eval(scal[[nr]]), cond=cond,e=e,formED=formED,theta=theta,scal=scal)
				ff1<-list()
        for (li in 1 : nr){
				  ff1[[li]]<-lsoda(cond,e[[li]],formED,theta,rtol=RtolEQ,atol=AtolEQ,hmax=Hmax)
          if (nr==1) ff1[[li]]<-ff1[[li]][,dim(ff1[[li]])[2]] [-1]
          else  ff1[[li]]<-ff1[[li]][,((dim(ff1[[li]])[2]-nr+1):(dim(ff1[[li]])[2]))][,li] [-1]
         
        }
      

				for (l in 1:nr){
          if (log.logical!=F) plot(tt[[l]],ff1[[l]],type='l',xlab='time',ylab=paste(names.data[l]),log=log.logical,ylim=c(y.range,range(ff1[[l]]))[1:2]) else  plot(tt[[l]],ff1[[l]],type='l',xlab='time',ylab=paste(names.data[l]),ylim=c(y.range,range(ff1[[l]]))[1:2])
      	
            #ff2[[l]]<-vector(mode="numeric", length(prots[[l]][[i]]))
          ff2<-list()
         for (j in 1:length(prots[[l]]))
				{
				      #ff2[[l]]<-lsoda(cond,c(time.condinit,sort(prots[[l]][[j]])),formED,theta,rtol=RtolEQ,atol=AtolEQ,hmax=Hmax)[,cmpt.of.interest[l]+1][-1]/eval(scal[[l]])
              ff2[[l]]<-lsoda(cond,c(time.condinit,sort(prots[[l]][[j]])),formED,theta,rtol=RtolEQ,atol=AtolEQ,hmax=Hmax)
              if (nr==1) ff2[[l]]<-ff2[[l]][,dim(ff2[[l]])[2]][-1] else ff2[[l]]<-ff2[[l]][,((dim(ff2[[l]])[2]-nr+1):(dim(ff2[[l]])[2]))][,l][-1]
               #print(ff2)
				       points(prots[[l]][[j]],ff2[[l]],pch=paste(j),cex=2,col=paste(j))
				       #print(prots[[l]][[j]])
				       title(paste( names.data[l],"model ","\n Initial Conditions = ", condinit[1],sep=" "))
         }
			       
        }

		}
		else
		{
			par(mfrow=c(nr,length(prots[[1]])))
		  e<-list()
      ff1<-list()
			ff2<-list()	
			for (l in 1:nr){
			 for (k in 1:length(prots[[l]]))
			 {
        cond<-eval(condinit[k])
        e<-lapply(1:nr,function(nr,time.condinit,tt) c(time.condinit,tt[[nr]]),time.condinit=time.condinit,tt=tt)
				ff1<-list()
        for (li in 1 : nr){
				  ff1[[li]]<-lsoda(cond,e[[li]],formED,theta,rtol=RtolEQ,atol=AtolEQ,hmax=Hmax)
          if (nr==1) ff1[[li]]<-ff1[[li]][,dim(ff1[[li]])[2]][-1]
          else  ff1[[li]]<-ff1[[li]][,((dim(ff1[[li]])[2]-nr+1):(dim(ff1[[li]])[2]))][,li] [-1]
        }
        if (log.logical!=F) plot(tt[[l]],ff1[[l]],type='l',xlab='time',ylab=paste(names.data[l]),log=log.logical,ylim=c(y.range,range(ff1[[l]]))[1:2]) else  plot(tt[[l]],ff1[[l]],type='l',xlab='time',ylab=paste(names.data[l]),ylim=c(y.range,range(ff1[[l]]))[1:2])
				
   
         ff2[[l]]<-lsoda(cond,c(time.condinit,sort(prots[[l]][[k]])),formED,theta,rtol=RtolEQ,atol=AtolEQ,hmax=Hmax)
         if (nr==1) ff2[[l]]<-ff2[[l]][,dim(ff2[[l]])[2]][-1] 
         else  ff2[[l]]<-ff2[[l]][,((dim(ff2[[l]])[2]-nr+1):(dim(ff2[[l]])[2]))][,l][-1]
         points(prots[[l]][[k]],ff2[[l]],pch=paste(k),cex=2)
	       #print(prots[[l]][[k]])
	       title(paste(names.data[l],"model  ","\n Initial Conditions ",  condinit[k],sep=" "))

				#ff2<-lsoda(cond,c(time.condinit,prot[[k]]),formED,theta,rtol=RtolEQ,atol=AtolEQ,hmax=Hmax)[,cmpt.of.interest[1]+1][-1]/eval(scale)
				#points(prot[[k]],ff2,pch=paste(k),cex=1)
				#title(paste("Initial Conditions",k,"= ", condinit[k],sep=" "))
			 }
		  }
      } 
}

#------------------------------------------------------------------------------
#------------------------------ OUTPUT -----------------------------------

out<-function()
{
	d<-Sys.time()
  f<-fisher()
	#print(1)
	p<-f$p 
	pp<-f$pp 
	se<-f$se 
	cv<-f$cv 
	mfisher<-f$somme 
	determinant<-f$det 
	crit<-f$crit 
	StdError<-se[1:p] 
	CV<-cv[1:p] 
	Beta<-theta 
	a<-data.frame(Beta,StdError,CV,row.names=parameters) 
	#print(2)
	.<-c(rep("%",p)) 
	a<-cbind(a,.) 
	Omega<-diag(as.matrix(omega1)) 
	StdError<-se[(p+1):(pp-lSIG)] 
	CV<-cv[(p+1):(pp-lSIG)] 
	b<-data.frame(Omega,StdError,CV,row.names=parameters[vec]) 
	.<-c(rep("%",(pp-p-lSIG))) 
	b<-cbind(b,.) 
	StdError<-se[(pp-(lSIG-1)):pp]
	CV<-cv[(pp-(lSIG-1)):pp]
	.<-rep("%",lSIG) 
	#sig.names<-c('sig.inter','sig.slope','sig.interPD','sig.slopePD')[vec2] 
  	sig.names<-unlist(c(f$xn))[vec2] 
	c<-cbind(data.frame(SIG,StdError,CV,row.names=sig.names),.)
	pm<-0
	ll<-lapply(prots,length)
	if(length(which(unlist(lapply(1:nr,function(nr) lapply(1:ll[[nr]], function(ll,prots,nr) length(prots[[nr]][[ll]]),prots=prots,nr=nr)))==0))==0){
	e<-lapply(1:nr,function(nr,subjects,prots) data.frame(subjects,row.names=as.character(prots[[nr]][1:length(prots[[nr]])])), subjects<-subjects,prots<-prots)
	pm<-1
	
  }
  #e<-data.frame(subjects,row.names=as.character(prots[[1]])) 
	#e1<-data.frame(subjects,row.names=as.character(prots[[2]])) 
	#print(4)
	sink((paste(directory,"\\",output,sep=""))) 
	cat("PFIM 3.0 ",'\n',"\n")
	cat("Project: ", project) 
	cat("\n","\n")
	cat('Date: ', date()) 
	cat("\n","\n")
	cat("\n","\n")
	cat("**************************** INPUT SUMMARY ********************************") 
	cat("\n","\n") 
	cat('Differential Equations form of the model: ','\n','\n') 
	#ff<-sapply(1:lf, function(lf, form) cat(paste(form[lf]),'\n','\n'), form=form)
	
	print(formED)
	cat("\n","\n")
	cat('Population design: ','\n')
  cat("\n","\n")
  for (i in 1:nr){
  cat('Sample times for response:',LETTERS[i],'\n')
  if (pm==1){
  print(e[[i]]) } else{
  print(prots[[i]])
  cat('               Number of subjects per group \n',t(t(subjects)),'\n')
  cat("\n","\n")
  }
  }
	#cat('Samples times for the',nr,'responses \n') 
	#print(e) 
	#cat("\n","\n")
	# cat('Samples times PD ','\n')
	#print(e1)
	cat("\n","\n")
  ff1<-sapply(1:nr,function(nr,sigmainter,sigmaslope) cat(paste('Variance error model response',LETTERS[nr],': (',sigmainter[[nr]],'+',sigmaslope[[nr]],"*f)^2",'\n','\n')),sigmainter<-sigmainter,sigmaslope<-sigmaslope)
	cat("\n","\n")
	#cat('Variance error model PK: (',sig.inter,'+',sig.slope,"*f)^2",'\n','\n')
  #cat('Variance error model PD: (',sig.interPD,'+',sig.slopePD,"*f)^2")
	#cat("\n","\n")
	cat('Initial Conditions at time', time.condinit,':','\n','\n')
	ff<-sapply(1:lp, function(lp, form) cat(paste(form[[lp]][-1]),'\n'), form=condinit)
	cat("\n","\n")
 
	cat("\n","\n")
	cat("Between-subject variance model: Trand = ",Trand) 
	cat("\n","\n") 
	cat("Error tolerance for solving differential equations system: RtolEQ =", RtolEQ,", AtolEQ =", AtolEQ,", Hmax = ",Hmax)
	cat("\n","\n") 
	cat("******************* POPULATION FISHER INFORMATION matrix ******************") 
	cat("\n","\n") 
	print(unclass(mfisher)) 
	cat("\n","\n") 
	cat("************************** EXPECTED STANDARD ERRORS ************************") 
	cat("\n","\n") 
	cat("------------------------ Fixed Effects Parameters -------------------------") 
  	 cat("\n","\n") 
	print(a) 
	cat("\n","\n") 
	cat("------------------------- Variance of Random Effects ----------------------") 
	cat("\n","\n") 
	print(b) 
	cat("\n","\n") 
	cat("------------------------ Variance of residual error ------------------------") 
	cat("\n","\n") 
	print(c) 
	cat("\n","\n") 
	cat("******************************* DETERMINANT ********************************") 
	cat("\n","\n") 
	cat(determinant) 
	cat("\n","\n") 
	cat("******************************** CRITERION *********************************") 
	cat("\n","\n") 
	cat(crit) 
	cat("\n","\n") 	
	cat("\n","\n") 
	d1<-Sys.time()
  print(d1-d)
	sink() 
	if(graph.logical==T)
  {
  graph(prots,graphinf,graphsup) 
  } 
  else NULL 
	cat('OK',"\n") 	
	return(prots,subjects,mfisher,determinant,crit,se,cv)
}



