#PFIM 3.0 Multiple responses
#Avril 2008
#Copyright  PFIM 3.0  Caroline Bazzoli, Sylvie Retout, Emmanuelle Comets, France Mentr - Universit Paris Diderot  INSERM.
#-----------------------------------------------------------------------------------

###########################################################################
# 	Computation of the Population Fisher Information matrix       	  #     
#	 for PK Design with analytical form of the model			 									 #							     
###########################################################################

options(expressions=1000)  
			
#---------------------- PRE - COMPUTATION ------------------------------------
#-----------------------------------------------------------------------------

subjects.init<-subjects
subjects.initA<-subjects.init
theta<-beta
lf<-length(form) #nombre de forme analytique
#nombre de form dans chaque rponse pour savoir quoi prendre en tf
#recover of the model
formg<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("form",LETTERS[1:nr],sep=""))  #sous forme de list
lformg<-lapply(formg,length)  #length(of each model tf or not)
c<-c(0,cumsum(lformg))
doses<-dose
p<-length(theta)
#Dform<-lapply(1:lf,function(p,form,parameters,lf) lapply(1:p,function(p,form,parameters) D(form,parameters[p]), form=form[lf],parameters=parameters),p=p,form=form,parameters=parameters)
#recover the inital data for all the models
if(identical.times==T){
prots<-lapply(1:nr,function(nr,x) get(x),x=paste("prot",LETTERS[1],sep=""))
}else
prots<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("prot",LETTERS[1:nr],sep=""))
 
Q<-length(prots[[1]])
#l_prote<-lapply(1:nr,function(p,forma,parameters,lf) lapply(1:p,function(p,forma,parameters) D(forma,parameters[p]), forma=forma[lf],parameters=parameters),p=p,forma=forma,parameters=parameters)
#nombre de prelevement par prot elementaire
#l_prote<-lapply(1:nr,function(nr,Q,prots) lapply(1:Q, function(nr,prots,Q) length(prots[[Q]]),Q=Q,prots=prots[[nr]]),Q=Q,prots=prots)
#somme des prevement spa rpto selon les reponses
l_prote<-list()
l2<-list()
for (l in 1:Q){
  l_prote[[l]]<-0
 
  for (i in 1:nr){
   l_prote[[l]]<-sum(l_prote[[l]],length(prots[[i]][[l]]))
 #l2[[l]]<-sum(l2[[l]],l_prote[[i]][[l]])
  
   l2[[i]]<-lapply(1:Q, function(Q,prots) length(prots[[Q]]),prots=prots[[i]])
   
 }
}

#lapply(1:Q,function(nr,l_prote,Q) lapply(1:nr, function(Q,l_prote,nr) sum(l_prote[[nr]][[Q]]),nr=nr,l_prote=l_prote),nr=nr,l_prote=l_prote)

sigmainter<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("sig.inter",LETTERS[1:nr],sep=""))
sigmaslope<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("sig.slope",LETTERS[1:nr],sep=""))

#tests si toutes les bornes
pres_b<-lapply(1:nr,function(nr,x) exists(x[nr]),x=paste("bound",LETTERS[1:nr],sep="")) 
TF<-which(pres_b==F) 
if(length(TF)==0) bornes<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("bound",LETTERS[1:nr],sep="")) else {

if(length(TF)==nr)  bornes<-rep(list(list(c(0,Inf))),nr) else { 
    bornes<-rep(list(list(c(0,Inf))),nr)
    for (i in 1:nr){ 
          if(length(which(TF==i))==0 ) {
             x=paste("bound",LETTERS[i],sep="")
             bornes[[i]]<-get(x)
          }
    }
 }
}
          
                    


#algo simplex
if (algo.option=="SIMP")  {
if (identical.times==T){
upper<-lapply(1:nr,function(nr,x) get(x),x=paste("upper",LETTERS[1],sep=""))
lower<-lapply(1:nr,function(nr,x) get(x),x=paste("lower",LETTERS[1],sep="")) }
else{
upper<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("upper",LETTERS[1:nr],sep=""))
lower<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("lower",LETTERS[1:nr],sep=""))
}
}

if (algo.option=="FW")  {
if (identical.times==T){
nwind<-lapply(1:nr,function(nr,x) get(x),x=paste("nwind",LETTERS[1],sep=""))
sampwin<-lapply(1:nr,function(nr,x) get(x),x=paste("sampwin",LETTERS[1],sep=""))
#sampwin<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("sampwin",LETTERS[1:nr],sep=""))
nsamp<-lapply(1:nr,function(nr,x) get(x),x=paste("nsamp",LETTERS[1],sep=""))
nmaxpts<-lapply(1:nr,function(nr,x) get(x),x=paste("nmaxpts",LETTERS[1],sep=""))
nminpts<-lapply(1:nr,function(nr,x) get(x),x=paste("nminpts",LETTERS[1],sep=""))
}else{
nwind<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("nwind",LETTERS[1:nr],sep=""))
sampwin<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("sampwin",LETTERS[1:nr],sep=""))
#sampwin<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("sampwin",LETTERS[1:nr],sep=""))
nsamp<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("nsamp",LETTERS[1:nr],sep=""))
nmaxpts<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("nmaxpts",LETTERS[1:nr],sep=""))
nminpts<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("nminpts",LETTERS[1:nr],sep=""))
}
}

#recover tf in order to compute the sensibility
tf<-vector(mode="list")
for (i in 1 : length(lformg)){

  if (lformg[i]!=1){ 
    tf[[i]]<-vector()
    tf[[i]][1]<-bornes[[i]][[1]][2]
    for (j in 2:lformg[[i]]){
      
      tf[[i]][j]<-c(bornes[[i]][[j]][2]) 
    }
  }
  else {
      tf[[i]]<-bornes[[i]][[1]][2]
  }     
} 


#attrape si il  ya une erreur#
erro<-tryCatch(graphinf<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("graph.inf",LETTERS[1:nr],sep="")),error=function(e) 1)          
#e=0 si pas d'erreur et 1 sinon#
if (length(which(unlist(erro)==1))>=1)
{
vecg<-replicate(nr,0)
graphinf<- as.vector(vecg,mode="list")
graphsup<-lapply(1:nr,function(nr,x) max(unlist(get(x[nr]))),x=paste("prot",LETTERS[1:nr],sep=""))
} else
{
graphinf<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("graph.inf",LETTERS[1:nr],sep=""))
graphsup<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("graph.sup",LETTERS[1:nr],sep=""))
}


#allow to build graph 
tt1<-list()
		#tt<-lapply(1:nr,function(nr,graphinf,graphsup) seq(graphinf,graphsup,0.1),graphinf<-graphinf[[nr]],graphsup<-graphsup[[nr]])	
	  for (l in 1:nr){
          tt1[[l]]<-list()
          if (length(bornes[[l]])==1){
            #if( bornes[[l]][[1]][1]> graphsup[[l]]) stop(" The upper limit for the graph  ",l,"  is too small")
            tt1[[l]][[1]]<-c(bornes[[l]][[1]][1]:graphsup[[l]])}
          else {
  		      for (i in 1: (length(bornes[[l]])-1)){
  		        tt1[[l]][[i]]<-c(bornes[[l]][[i]][1]:bornes[[l]][[i]][2])
  		        if(i==length(bornes[[l]])-1){
  		          #if (bornes[[l]][[i]][2]>graphsup[[l]]) stop(" The upper limit (graph.sup)  for the response  ",LETTERS[ l]  ,"  is too small")
  		          tt1[[l]][[i+1]]<-c(bornes[[l]][[i]][2]:graphsup[[l]])}
             }
          }
    }
tt1b<-lapply(1:nr,function(nr,tt1) unlist(tt1[[nr]]),tt1<-tt1)
tt1<-lapply(1:nr,function(nr,tt1b) tt1b[[nr]][tt1b[[nr]]>=graphinf[[nr]][1] & tt1b[[1]]<=graphsup[[nr]][1]],tt1b<-tt1b) 

#test if we have NULL in the prots in this case we can not optimise with same sampling time 
ll<-lapply(prots,length)
		if(identical.times==T && length(which(unlist(lapply(1:nr,function(nr) lapply(1:ll[[nr]], function(ll,prots,nr) length(prots[[nr]][[ll]]),prots=prots,nr=nr)))==0))!=0)
		       identical.times=F

if (subjects.input==1) 
	{
	Nt<-lapply(1:nr, function(nr,subjects.init,l2) sum(subjects.init*unlist(l2[[nr]])),subjects.init=subjects.init,l2=l2)
	Ntot<-sum(unlist(Nt))
	subjects.total<-sum(subjects.init)
	subjects.initN<-subjects.init
	subjects.init<-subjects.init/subjects.total
	subjects<-subjects.init
	} else    
	
subjects<-subjects.init


if (dose.identical==T) doses<-rep(doses,length(prots[[1]])) else NULL
condinit<-NULL
#-----------------------------------------------------------------------------
#------------------------ COMPUTE --------------------------------------------

#Function used in Population Fisher information matrix  function 
#------------------------------------
pts<-function(nr,i,prots){
protk<-c()
lprotk<-c()
for (k in 1:nr){
protk <-c(protk,prots[[k]][i])  
#lprotk<-c(protk,prots[[k]][i])
}
return(protk)
}


#Sensitivity matrix :
#-------------------- 
#Sensitivity matrix :
#--------------------
sensibilite<-function(nr,protk,k,lprotk,doses) #m=modele pk ou pd proti=prelevemet pk et protiPD=prelevementPD#
{	            #protk represente touts les temps de prelevement de toute les reponses pour le k ieme protocle elementaire
  #c<-length(proti) #nombre de prelevement par protocle elementaire
	#c1<-length(protiPD)
	#lprotk<-lapply(1:nr,function(nr,protk,lprotk) length(protk[[nr]]),protk=protk )
	dose<-doses[k]
	s1<-matrix(nrow=p,ncol=0)
	mod<-numeric()
	mod1<-numeric()

	for (i in 1:p) {assign(parameters[i],theta[i]) }

	 for (l in 1 :nr){
	    #dat<-se(lprotk,protk,dose,form,tf,l)
	    #mod1<-c(mod1,dat[[1]])
	    #s1<-cbind(s1,dat[[2]])
	    mod<-numeric()
      s<-matrix(nrow=p,ncol=lprotk[[l]])
	     for (i in 1:p){
	         for (j in 1:lprotk[[l]])
		       {
               vlf<-1:lformg[[l]]
               forma<-formg[[l]]
               lf<-length(forma)
               Dforma<-lapply(1:lf,function(p,forma,parameters,lf) lapply(1:p,function(p,forma,parameters) D(forma,parameters[p]), forma=forma[lf],parameters=parameters),p=p,forma=forma,parameters=parameters)
               #c<-c(0,cumsum(lformg))
			         t<-protk[[l]][j]
			         ff1<-formg[[l]][t<=tf[[l]]][1]
		           #Dforma<-Dform[[c[l]+1:lformg[[l]]]]
		           #tfa<-tf[[l]]
			          #v<- c[l]+1
			         u<-eval(Dforma[[vlf[t<=tf[[l]]][1]]][[i]])#*dose #
			         #u<-eval(Dform[[vlf[t<=tfa]]][[i]])
			         
	             if (Trand ==2)  u<-theta[i]*u
			         mod[j]<-eval(ff1)#*dose #
               s[i,j]<-u
		        }
	     }                                         
	   mod1<-c(mod1,mod)
	   s1<-cbind(s1,s)
  }
   l<-list(mod1,s1)
	return(l)
}


# Fisher matrix for 1 ind in 1 elementary design by block: block A (resA), block B(resB), block C (resC)
#-------------------------------------------------------------------------------------------------------
bloc<-function(protk,sensi,var,invvar,dvar,mod,lprotk,bout4)   #proti,protiPD,sensi,var,invvar,dvar,mod

{
  #c<-length(proti) 
	#c1<-length(protiPD)
	resB<-matrix(nrow=p+nr*2,ncol=p+nr*2)     #matrice alatoire #
	resC<-matrix(rep(0,(p+nr*2)*p),nrow=p+nr*2,ncol=p)     #matrice incomplete option 1 covariance==0#

	if (Trand==2) sensia<-sensi/theta 	else sensia<-sensi #?????#
	
	resA1<-(sensia %*% invvar) %*% t(sensia)  #matrice parametres fixe#
	
	#sigma inter PK#
	#a1<-2*diag(c(sig.inter+sig.slope*mod[1:c],rep(0,length(protiPD))),length(c(proti,protiPD)))
	#a3<-invvar%*%a1%*%invvar
	#resB[p+1,p+1]<-sum(diag(a3%*%a1))
	#sigma slope PK#
	#a2<-a1*mod
	#print(a2)
  #resB[p+2,p+2]<-sum(diag(a2%*%invvar%*%a2%*%invvar))
  #print(resB[p+2,p+2])
	#sigma inter PK et sigma slope PK#
	#resB[p+1,p+2]<-sum(diag(a3%*%a2))
	#resB[p+2,p+1]<-resB[p+1,p+2]
	
	l1<-list()
	li<-list()
	l2<-list()
	#premiere rponse
	c<-cumsum(unlist(lprotk))
	long<-c[nr]-c[1]
  a1<-2*diag(c(bout4[[1]],rep(0,long)),length(unlist(protk)))
	ai<-invvar%*%a1%*%invvar
	resB[p+1,p+1]<-sum(diag(ai%*%a1))
	a2<-a1*mod
	resB[p+2,p+2]<-sum(diag(a2%*%invvar%*%a2%*%invvar))
	resB[p+1,p+2]<-sum(diag(ai%*%a2))
	resB[p+2,p+1]<-resB[p+1,p+2]
	l1[[1]]<-a1
	li[[1]]<-ai
	l2[[1]]<-a2
	
	if (nr!=1){
	for (i in 1:(nr-1)){
	long<-c[i]
  vec<-rep(0,length(unlist(protk)))
  if(length(bout4)==nr){
  vec[long+1:(lprotk[[i+1]])]=bout4[[i+1]]
  }else{
  vec<-vec
  } 
   #for each response
	#a1<-2*diag(c(sig.inter+sig.slope*mod[1:c],rep(0,length(protiPD))),length(c(proti,protiPD)))
	#a1<-2*diag(c(rep(0,long)),bout4[i+1]),length(unlist(protk)))
	a1<-2*diag(vec,length(unlist(protk)))
	#a3<-invvar%*%a1%*%invvar
	ai<-invvar%*%a1%*%invvar
	#sigma inter
	#resB[p+1,p+1]<-sum(diag(a3%*%a1))
	resB[p+i*2+1,p+i*2+1]<-sum(diag(ai%*%a1))
	#sigma slope #
	a2<-a1*mod
	#print(a2)
	#resB[p+2,p+2]<-sum(diag(a2%*%invvar%*%a2%*%invvar))
  resB[p+i*2+2,p+i*2+2]<-sum(diag(a2%*%invvar%*%a2%*%invvar))
  #print(resB[p+2,p+2])
  
	#sigma inter  et sigma slope 
	#resB[p+1,p+2]<-sum(diag(a3%*%a2))
	#resB[p+2,p+1]<-resB[p+1,p+2]
	resB[p+(i*2)+1,p+i*2+2]<-sum(diag(ai%*%a2))
	resB[p+i*2+2,p+(i*2)+1]<-resB[p+(i*2)+1,p+i*2+2]
	l1[[i+1]]<-a1
	li[[i+1]]<-ai
	l2[[i+1]]<-a2
  }
 
  
	#sigma inter PD#
	#a4<-2*diag(c(rep(0,length(proti)),sig.interPD+sig.slopePD*mod[(c+1):(c+c1)]),length(c(proti,protiPD)))
	#a4b<-invvar%*%a4%*%invvar
  #resB[p+3,p+3]<-sum(diag(a4b%*%a4))
  #sigma slope PD#
  #a5<-a4*mod
	#resB[p+4,p+4]<-sum(diag(a5%*%invvar%*%a5%*%invvar))
  #sigma slope PD et sigma inter PD#
	#resB[p+4,p+3]<-sum(diag(a4b%*%a5))  resB[p+3,p+4]<-resB[p+4,p+3]
	
  #sigma inter PD et sigma inter PK#
  for (i in 1: (nr)){
    for (j in  2 : (nr)){
	#resB[p+3,p+1]<-sum(diag(a4b%*%a1))  resB[p+1,p+3]<-resB[p+3,p+1]    #ai[2]*a1
	#resB[p+3,p+1]<-sum(diag(li[2]%*%l1[1]))  resB[p+1,p+3]<-resB[p+3,p+1]
	     resB[(p+j*2-1),p+i*2-1]<-sum(diag(li[[j]]%*%l1[[i]])) 
       resB[p+i*2-1,(p+j*2-1)]<-resB[(p+j*2-1),p+i*2-1] #resB[p+1,p+3]<-resB[p+3,p+1]
	#sigma slope PD et sigma inter PK#
	#resB[p+4,p+1]<-sum(diag(li[1]%*%l2[2])) 	resB[p+1,p+4]<-resB[p+4,p+1]
	     resB[p+j*2,p+i*2-1]<-sum(diag(li[[i]]%*%l2[[j]])) 	#resB[p+1,p+4]<-resB[p+4,p+1]
       resB[p+i*2-1,p+j*2]<-resB[p+j*2,p+i*2-1]
	#sigma inter PD et sigma slope PK#
	#resB[p+3,p+2]<-sum(diag(li[2]%*%l2[1]))  resB[p+2,p+3]<-resB[p+3,p+2]
	     resB[p+j*2-1,p+i*2]<-sum(diag(li[[j]]%*%l2[[i]]))  #resB[p+2,p+3]<-resB[p+3,p+2]
	     resB[p+i*2,p+j*2-1]<-resB[p+j*2-1,p+i*2]
	#sigma slope PD et sigma slope PK#
	#resB[p+4,p+2]<-sum(diag(invvar%*%l2[2]%*%invvar%*%l2[1])) resB[p+2,p+4]<-resB[p+4,p+2]
	     resB[p+j*2,p+i*2]<-sum(diag(invvar%*%l2[[j]]%*%invvar%*%l2[[i]]))
       resB[p+i*2,p+j*2]<-resB[p+j*2,p+i*2] #resB[p+2,p+4]<-resB[p+4,p+2]
	}
	}
	
	for (i in 1:p)
	{
		resB1<-sensi[i,]%*%t(sensi[i,])
		resB2<-invvar%*%resB1%*%invvar
		resB[i,1:p]<-sapply(1:p,function(resB2,sensi,p) sum(diag(resB2%*%sensi[p,]%*%t(sensi[p,]))),resB2=resB2,sensi=sensi)
		resB[i,p+1]<-sum(diag(l1[[1]]%*%resB2))
		resB[i,p+2]<-sum(diag(l2[[1]]%*%resB2))

    for ( j in 2:nr) {
    
		resB[i,p+j*2-1]<-sum(diag(l1[[j]]%*%resB2))
		resB[i,p+j*2]<-sum(diag(l2[[j]]%*%resB2)) 	
	 }
  resB[(p+1):(p+(2*nr)),i]<-resB[i,(p+1):(p+(2*nr))]
  }
  } else {
  
   for (i in 1:p)
	{
		resB1<-sensi[i,]%*%t(sensi[i,])
		resB2<-invvar%*%resB1%*%invvar
		resB[i,1:p]<-sapply(1:p,function(resB2,sensi,p) sum(diag(resB2%*%sensi[p,]%*%t(sensi[p,]))),resB2=resB2,sensi=sensi)
		resB[i,p+1]<-sum(diag(l1[[1]]%*%resB2))
		resB[i,p+2]<-sum(diag(l2[[1]]%*%resB2))
		resB[(p+1):(p+2),i]<-resB[i,(p+1):(p+2)]	
	}
  }
  
  
	resB<-0.5*resB 
	#print(resB)
	h<-cbind(rbind(resA1,resC),rbind(t(resC),resB))
	#print(h)
	return(h) 
}



fisher<-function(prots,subjects,condinit,doses,Ntot,ind=0,l_prote)
{	
  
  #Nbsubjects<-Ntot/sum((nq+np)*subjects) 
  Nbsubjects<-Ntot/sum((unlist(l_prote)*subjects)) 
  #n<-np+nq 
  n<-sum(unlist(l_prote))              #nq=nombre de prelevements par protocoles elementaires#
	if(ind==2) Nbsubjects<-1
	pp<-2*p+2*nr #2 parameters for the residual variance by response#
	somme<-matrix(c(rep(0,pp*pp)),ncol=pp) 
	se<-numeric() 
	cv<-numeric() 
	
	#for(i in 1: length(prots[[1]])) 
  for(i in 1: length(l_prote))  #pour chaque protocole meme nombre de protocole elementaire en pk et pd#
	{
	    #print(i)
      protk<-pts(nr,i,prots)
	    	  #cat(i,"- Computation of the elementary Fisher information matrix for elementary protocol:",protk,"\n")
	   # print(protk)
	    lprotk<-lapply(1:nr,function(nr,protk) length(protk[[nr]]),protk=protk )
      #protk<-lapply(1:nr,function(nr,i,prots) pts(nr,i,prots[[nr]]),prots=prots,i=i)
      #lprotk<-lapply(1:nr,function(nr,protk) length(protk[[nr]][[1]]),protk=protk )
			#c<-length(proti) 
	    #c1<-length(protiPD)
	    #sensibili<-lapply(1:nr, function(nr,protk,i) sensibilite(protk,i),protk=protk,i=i))
			sensibili<-sensibilite(nr,protk,i,lprotk,doses)  #i the elementar protocol
			#print(sensibili)
			mod<-sensibili[[1]] 
			sensi<-sensibili[[2]] 
			bout1<-omega%*%sensi
			#print(bout1)
					bout4<-list()
			t1<-0
			t<-0
			for (n in 1:(nr)){
			t<-1+t1
			t1<-t-1+lprotk[[n]]
			#print(c(t:t1))
			if(lprotk[[n]]==0){
			bout4[[n]]<-NULL 
      if(n==nr){bout4[[n+1]]=Inf}
      } else {
			bout3<-sigmainter[[n]]+sigmaslope[[n]]*mod[t:t1]
			bout4[[n]]<-bout3
			}
			}
			t<-NULL
			t1<-NULL
      #bout3<-list(bout3,sigmainter+sigmaslope*mod[1:c]
      #modele PK#
			#print(bout3)
			#bout4<-sig.interPD+sig.slopePD*mod[(c+1):(c+c1)] #modele PD#
			#print(bout4)
			#print(diag(c(bout3^2,bout4^2),length(c(proti,protiPD))))
			var<-t(bout1) %*% sensi + diag(unlist(bout4[1:nr])^2,length(unlist(protk))) 
			#print(var)
			invvar<-solve(as.matrix(var)) 
      #print(invvar)
			#fish<-bloc(proti,protiPD,sensi,var,invvar,dvar,mod)
      fish<-bloc(protk,sensi,var,invvar,dvar,mod,lprotk,bout4) 
			#print(fish)
			somme<-somme+ subjects[i]*Nbsubjects*fish 
      #print(somme)	
		}
	
	
	#SIG<<-c(sig.inter,sig.slope,sig.interPD,sig.slopePD)
	sigmaslopen<-lapply(1:nr,function(nr,x) x[nr],x=paste("sig.slope",LETTERS[1:nr],sep=""))
  sigmaintern<-lapply(1:nr,function(nr,x) x[nr],x=paste("sig.inter",LETTERS[1:nr],sep=""))
  xn<-rbind(sigmaintern,sigmaslopen)
  xv<-rbind(sigmainter,sigmaslope)
  SIG<<-unlist(c(xv))
  SIGN<<-unlist(c(xn))
	vec2<<-SIG!=0
	SIG<<-SIG[vec2]	
	SIGN<-SIGN[vec2]
	lSIG<<-length(SIG)	
	
	vec<<-diag(omega)!=0 
	omega1<<-as.matrix(omega[,vec])[vec,] 
	vec<-c(rep(T,p),vec,vec2) 
 		#remove the row i and the col i of somme if omega[i,i]=0  
	somme<-somme[,vec][vec,] 
	if (ind==2) l<-list(somme) else
    {
	   pp<-dim(somme)[1] 
	   det<-det(somme)	 #Fisher determinant
#	   det<-crit(criterion,somme,pp)
	   if (det==0) crit<-1e-99	else crit<-(det)^(1/pp)	  #dans le cas o le protocole est degenere
     invcrit<-1/crit 
	   #print(invcrit)
     if (ind==0) l<-invcrit else
		    {
		    f<-fisher.cv(somme,pp,SIG,omega1)
		    inv<-f[[1]]
		    se<-f[[2]]
		    cv<-f[[3]]
		    l<-list(somme,doses,prots,inv,se,cv,det,crit,p,pp,subjects,xn)
 		     }
 	}
 	
 return(l)
  
}

fisher.cv<-function(somme,pp,SIG,omega1)
{
	inv<-try(solve(as.matrix(somme)))
	if(!is.null(attributes(inv)$class))
	{
		se<-rep(NA,pp)
		cv<-se
	}		
	else
		{
		se<-sqrt(diag(inv)) 
		cv1<-se[1:p]/theta*100 
		cv2<-se[(p+1):(pp-lSIG)]/diag(omega1)*100 
		cv3<-se[(pp-(lSIG-1)):pp]/SIG*100 
		cv<-abs(c(cv1,cv2,cv3))
		}
	l<-list(inv,se,cv)
	return(l)
}

#function to build graph
graph<-function(prots,protopti)
{
		for (i in 1:p) {assign(parameters[i],theta[i]) }

		if ((dose.identical==T)||(dose.identical==F && algo.option=="FW"))
		{
		    dose<-doses[1] 
		    ff1<-list()
		    ff2<-list()
        par(mfrow=c(1,nr))
        for (l in 1 : nr){
		        ff1[[l]]<-vector(mode="numeric", length(tt1[[l]]))
				    for (j in 1:length(tt1[[l]]))
	          {
              #ff1[[l]]<-vector(mode="numeric",length=length(tt[[l]]))
				      t<-tt1[[l]][j]
				      #print(t)
				      #ff1[[l]]<-vector()
				      #ff1[[l]]<-lapply(1:length(tt[[l]]),function(tt,tf,formg,l,t) eval(formg[t<=tf][1]),tf<-tf[[l]],formg<-formg[[l]],l<-l,t<-tt[[l]][j])
				      ff1[[l]][j]<-eval(formg[[l]][t<=tf[[l]]][1])
              #plot(tt[[l]],ff1[[l]],type='l',xlab='Time',ylab='Concentration',log="y",ylim=c(y.range,range(ff1[[l]]))[1:2])
				      #print(ff1[[l]])
              #ff1[j]<-eval(form[t<=tf][1])#*dose[1]  #          
              #ff3[j]<-eval(form[t<=tf][2])#*dose[1] #		
  		      }
  		      if(log.logical!=F) plot(tt1[[l]],ff1[[l]],type='l',xlab='Time',ylab=paste(names.data[l]),log=log.logical,ylim=c(y.range,range(ff1[[l]]))[1:2]) else   plot(tt1[[l]],ff1[[l]],type='l',xlab='Time',ylab=paste(names.data[l]),ylim=c(y.range,range(ff1[[l]]))[1:2])
        
            #points for the design on the graph
				          
				          for ( i in 1:length(protopti[[l]]))
				          {
				          ff2[[l]]<-vector(mode="numeric", length(protopti[[l]][[i]]))
				            for ( j in 1:length(protopti[[l]][[i]])) {
				    	          t<-protopti[[l]][[i]][j]
					              ff2[[l]][j]<-eval(formg[[l]][t<=tf[[l]]][1])#*dose[1] #
		                }
				                #points(prots[[l]][[i]],ff2[[l]],pch=paste(i),cex=2,col=paste(i))
				                points(protopti[[l]][[i]],ff2[[l]],pch=paste(i),cex=2,col=paste(i))
	                }
             
		      }
      }
		else
		{
	    ff1<-list()
	    par(mfrow=c(nr,length(protopti[[1]])))
			for (l in 1 : nr){
			  
			 ff1[[l]]<-vector(mode="numeric", length(tt1[[l]]))
			     for (k in 1:length(protopti[[l]]))
			     {
			#windows()
			#par(mfrow=c(1,2))
			       dose<-doses[k]
				      for (j in 1:length(tt1[[l]]))
				      {
				      	 t<-tt1[[l]][j]
				       ff1[[l]][j]<-eval(formg[[l]][t<=tf[[l]]][1])#*dose[k]  #
                
			      }
	         
			      if (log.logical!=F) 
			          plot(tt1[[l]],ff1[[l]],type='l',xlab='time',ylab=paste(names.data[l]),log=log.logical,ylim=c(y.range,range(ff1[[l]]))[1:2]) else plot(tt1[[l]],ff1[[l]],type='l',xlab='time',ylab=paste(names.data[l]),ylim=c(y.range,range(ff1[[l]]))[1:2])
				
        
              ff2<-list()
              ff2[[l]]<-vector(mode="numeric", length(protopti[[l]][[k]]))
				      for ( i in 1:length(protopti[[l]][[k]]))
				      {
	               dose<-doses[k]
					       t<-protopti[[l]][[k]][i]
					       ff2 [[l]][i]<-eval(formg[[l]][t<=tf[[l]]][1])#*dose[k] #				
		          }
           	    #points(prots[[l]][[k]],ff2[[l]],pch=paste(k),cex=2,col=paste(k))
           	    points(protopti[[l]][[k]],ff2[[l]],pch=paste(k),cex=2,col=paste(k))
			         	title(paste("Group",k,"- dose = ", doses[k],sep=" "))
			}
			}
      	
		}		
}






