#PFIM 3.0 Multiple responses
#Avril 2008
#Copyright  PFIM 3.0  Caroline Bazzoli, Sylvie Retout, Emmanuelle Comets, France Mentr - Universit Paris Diderot  INSERM.
#-----------------------------------------------------------------------------------

#En cours : scurisation du code pour viter l'abondance de variables globales

############################################################################
####                Data, model and first derivatives for all times                ####
############################################################################

########################################
#Create table with times, doses, form and response for each time considered
create.timdos<-function(model.info,struc.info,sampl.info,init.info) {
#Needed to test which form should be used for each sampling time
  comp.bnd<-function(t,boundaries) {
     max(which(unlist(lapply(1:length(boundaries),
     function(i) ((boundaries[[i]][1]-t)*(boundaries[[i]][2]-t)<=0)))))
  }
  nr<-model.info$nr
  tab<-NULL
  if(struc.info$modelform=="AF") {
    wlform<-0
    for(l in 1:nr) {
      wsamp<-sampl.info$sampwin[[l]]
      boundary<-struc.info$bound[[l]] #ECO TODO : vrifier si a marche
      times<-sort(unique(unlist(wsamp)))
      tim.dos<-data.frame(times=times,doses=rep(init.info$doses[1],length(times)),
      condnum=rep(1,length(times)),irep=rep(l,length(times)))
      ifor<-unlist(lapply(tim.dos[,1],comp.bnd,boundaries=boundary))+wlform
      tim.dos<-cbind(tim.dos,iform=ifor)
#eco TODO : sort this...
      wlform<-wlform+struc.info$lformg[[l]]
      tab<-rbind(tab,tim.dos)
      }
    tim.dos<-tab
    if(!init.info$dose.identical & length(init.info$doses)>1) {
      tab1<-tim.dos;nl<-dim(tim.dos)[1]
      for(idos in 2:length(init.info$doses)) {
        tab1$doses<-rep(init.info$doses[idos],nl)
        tab1$condnum<-rep(idos,nl)
        tab1$iform<-tab1$iform+struc.info$lf
        tim.dos<-rbind(tim.dos,tab1)
      }
    }
    tim.dos<-cbind(id=paste(tim.dos$times,tim.dos$irep,tim.dos$condnum,sep="x"),
      tim.dos)
  } else { #model is DE
    for(l in 1:nr) {
       wsamp<-sampl.info$sampwin[[l]]
       times<-sort(unique(unlist(wsamp)))
# eco : condnum contains the condinit group (1,..length(condinit))
       cond.number<-rep(1,length(times))
       tim.dos<-data.frame(times=times,condnum=cond.number,
       irep=rep(l,length(times))) #,time.init=time.init)         
    tab<-rbind(tab,tim.dos)
    }
    tim.dos<-tab
    if(!init.info$condinit.identical & length(init.info$condinit)>1) {
      tab1<-tim.dos;nl<-dim(tim.dos)[1]
      for(idos in 2:length(init.info$condinit)) {
        tab1$condnum<-rep(idos,nl)
        tim.dos<-rbind(tim.dos,tab1)
      }
    }
    tim.dos<-cbind(id=paste(tim.dos$times,tim.dos$irep,tim.dos$condnum,sep="x"),
      tim.dos)
  }
  sig.i<-unlist(lapply(1:dim(tim.dos)[1],function(i) model.info$sigmainter[[tim.dos$irep[i]]]))
  sig.s<-unlist(lapply(1:dim(tim.dos)[1],function(i) model.info$sigmaslope[[tim.dos$irep[i]]]))
  tim.dos<-cbind(tim.dos,sig.i=sig.i,sig.s=sig.s)
  return(tim.dos)
}

########################################
# Derivation symbolique des drives premires et secondes
#Speeden up the computation by only getting the symbolic derivatives of
# the forms we do need

symbolic.prem<-function(model.info,struc.info,kform) {
#Calcule les drives premires et secondes du modle de faon symbolique
  p<-length(model.info$beta)
  for (i in 1:p) 
    assign(parameters[i],model.info$beta[i])
#Derive premire
# liste de longueur Sum_l (n_l)
# chaque lment de la liste est un vecteur de taille p (nb paramtres)
  df.forms<-vector(length(struc.info$form),mode="list")
  for(l in kform) {
    formi<-struc.info$form[[l]]
    df.forms[[l]]<-unlist(lapply(1:p,function(i,formi) D(formi,parameters[i]),
     formi=formi))
  }
  return(list(df.forms=df.forms))
}

########################################
# Compute model predictions and first derivatives for all protocol times
# for a model in analytical form

calc.modelprem<-function(tim.dos,model.info,struc.info,df.forms) {
  p<-length(model.info$beta)
  for (i in 1:p) 
     assign(parameters[i],model.info$beta[i])
#model function
  f.p<-unlist(lapply(1:dim(tim.dos)[1],function(i,tab,formi) {
     t<-tab$times[i]
     dose<-tab$doses[i]
     ifo<-tab$iform[i]
     return(eval(formi[[ifo]])) },tab=tim.dos,formi=struc.info$form))
  f.p<-matrix(f.p,nrow=1)
#first derivatives
  df.p<-matrix(nrow=p,ncol=dim(tim.dos)[1])
  for(i in 1:dim(tim.dos)[1]) {
    t<-tim.dos$times[i]
    dose<-tim.dos$doses[i]
    ifo<-tim.dos$iform[i]
    df.i<-df.forms[[ifo]]
    vec<-unlist(lapply(1:p,function(i) eval(df.i[[i]])))
    if(model.info$Trand==2) vec<-vec*model.info$beta
    df.p[,i]<-vec
  }
  return(list(mod=f.p,sensi=df.p))
}

########################################
# Compute model predictions and first derivatives for all protocol times
# for a model described by differential equations

inter<-function(theta,model.info,k,l,init.info,formED,condinit)  {
  p<-length(model.info$beta)
  for (i in 1:p) 
     assign(parameters[i],theta[i])
  cond<-eval(condinit[k])
  res<-lsoda(cond,times=c(init.info$time.condinit,theta[p+1]),
    formED,theta,rtol=init.info$RtolEQ,
    atol=init.info$AtolEQ,hmax=init.info$Hmax)
  if (model.info$nr==1)
     res<-res[,dim(res)[2]][2]
  else 
     res<-res[,((dim(res)[2]-model.info$nr+1):(dim(res)[2]))][,l] [-1]
 return(res) 
}

calc.model.de<-function(tab,model.info,init.info,struc.info) {
  p<-length(model.info$beta)
  formED<-struc.info$formED
  for (i in 1:p) 
     assign(parameters[i],model.info$beta[i])
#model function
   df.p<-NULL
   f.p<-NULL
   l0<-0
   for(k in 1:length(unique(tab$condnum))) {
     cond<-eval(init.info$condinit[k])
     fmod<-list()
     dd<-list()
     for(l in 1:model.info$nr) {
       tim<-tab$times[tab$irep==l & tab$condnum==k]
       fmod[[l]]<-lsoda(cond,c(init.info$time.condinit,tim),struc.info$formED,
         model.info$beta,rtol=init.info$RtolEQ,atol=init.info$AtolEQ,
         hmax=init.info$Hmax)
       if (model.info$nr==1) { #single response
         fmod[[l]]<-fmod[[l]][,dim(fmod[[l]])[2]][-1] 
       } else 
         fmod[[l]]<-fmod[[l]][,
           ((dim(fmod[[l]])[2]-model.info$nr+1):(dim(fmod[[l]])[2]))][,l][-1]
       f.p<-c(f.p,fmod[[l]])
       lfd<-length(tim)
       dd[[l]]<-lapply(1:lfd,function(lfd,beta,tim,k,t,l,model.info,init.info,
         formED,condinit) fdHess(c(beta,tim[lfd]),inter,model.info=model.info,
         k=k,l=l,init.info=init.info,formED=formED,condinit=condinit)$gradient,
         beta=model.info$beta,tim=tim,k=k,l=l,model.info=model.info,
         init.info=init.info,formED=struc.info$formED,
         condinit=init.info$condinit)
       df1<-t(matrix(unlist(dd[[l]]),ncol=length(tim)))[,1:p] 
       if(length(tim)==1) df1<-matrix(df1,nrow=p,ncol=1) else df1<-t(df1)
       if (model.info$Trand==2) df1<-df1*model.info$beta
       df.p<-cbind(df.p,df1)
     }
   }
  return(list(mod=f.p,sensi=df.p))
}

############################################################################
####                Fisher information matrix, method 1                 ####
############################################################################
#Only Fisher information matrix (for each elementary protocol)

ecofisher.meth1<-function(ind1,tab,f.p,df.p,model.info) {
#No computation of C
#neglect all terms involving d2.f
#ind1 : indices des temps (ranges de tab)
#tab : a table with times, doses, form and response for each time considered
#Computes only the Fisher information matrix (assumes elementary protocol)
  p<-length(model.info$beta)
  nr<-model.info$nr

#Calcul de V et V-1
   v1<-model.info$omega%*%df.p[,ind1]
   vvar<-t(v1)%*%df.p[,ind1]
   dia<-(tab$sig.i[ind1]+tab$sig.s[ind1]*f.p[ind1])**2
   vvar<-vvar+diag(dia,nrow=length(dia))
   invvar<-solve(vvar)
   
#Calcul des dV/dlambda_m.V-1 (m=1...p)
   dvdlam<-vector(p+2*nr,mode="list")
   for(m in 1:p) {
     dv1<- df.p[m,ind1]%*%t(df.p[m,ind1])
     dvdlam[[m]]<-dv1%*%invvar
   }

#Calcul des dV/dlambda_m.V-1 (m>p)
   vecmi<-2*(tab$sig.i[ind1]+tab$sig.s[ind1]*f.p[ind1])
   vecms<-vecmi*f.p[ind1]
   for(l in 1:(2*nr))
      dvdlam[[p+l]]<-diag(rep(0,length(vecmi)),nrow=length(vecmi))
   for(l in 1:nr) { #sigma.inter
      if (model.info$sigmainter[[l]]>0) {
       diag(dvdlam[[p+(l-1)*2+1]])[tab$irep[ind1]==l]<-vecmi[tab$irep[ind1]==l]
       dvdlam[[p+(l-1)*2+1]]<-dvdlam[[p+(l-1)*2+1]]%*%invvar
       }
      }
   for(l in 1:nr) { #sigma.slope
      if (model.info$sigmaslope[[l]]>0) { 
       diag(dvdlam[[p+(l-1)*2+2]])[tab$irep[ind1]==l]<-vecms[tab$irep[ind1]==l]
       dvdlam[[p+(l-1)*2+2]]<-dvdlam[[p+(l-1)*2+2]]%*%invvar
       }
      }
   resB<-matrix(nrow=p+nr*2,ncol=p+nr*2)     #matrice alatoire #
   resC<-matrix(rep(0,(p+nr*2)*p),nrow=p+nr*2,ncol=p)     #matrice incomplete option 1 covariance==0#
#Division par beta dns le cas Trand==2
   if(model.info$Trand==2) df1<-df.p[,ind1]/model.info$beta else df1<-df.p[,ind1]
   resA<-(df1 %*% invvar) %*% t(df1)  #matrice parametres fixe#
   for(i in 1:(p+2*nr)) {
      for(j in 1:(p+2*nr)) {
        resB[i,j]<-sum(diag(dvdlam[[i]]%*%dvdlam[[j]]))
        }
   }
   resB<-resB/2
#Enlever les lignes de B et C pour lesquelles omega ou sigma=0
   if(length(model.info$nullpar)>0) {
     resB<-resB[-c(model.info$nullpar),-c(model.info$nullpar)]
     resC<-resC[-model.info$nullpar,]
   }
   fish<-cbind(rbind(resA,resC),rbind(t(resC),resB))
   return(fish)
}

#Population information matrix
fisher.cv<-function(somme,pp,SIG,omega1,beta) {
#somme=FIM for the population design
   p<-length(beta)
   inv<-try(solve(as.matrix(somme)))
   if(!is.null(attributes(inv)$class)) {
      se<-rep(NA,pp)
      cv<-se
   }      
   else {
      se<-sqrt(diag(inv)) 
      cv1<-se[1:p]/beta*100 
      cv2<-se[(p+1):(pp-length(SIG[SIG!=0]))]/diag(omega1)*100 
      cv3<-se[(pp-(length(SIG[SIG!=0])-1)):pp]/SIG[SIG!=0]*100 
      cv<-abs(c(cv1,cv2,cv3))
      }
   l<-list(inv,se,cv)
   return(l)
}

#Compute the population information matrix for the final protocol (case ind=1)
ecofisher.meth1.final<-function(lprot,tab,f.p,df.p,subjects,model.info,
  cost){
   Nbsubjects<-cost/sum((unlist(lapply(lprot,length))*subjects)) 
   nr<-model.info$nr
   p<-length(model.info$beta)
   pp<-2*p+2*nr-length(model.info$nullpar) #2 parameters for the residual variance by response#
   somme<-matrix(c(rep(0,pp*pp)),ncol=pp) 
   se<-numeric() 
   cv<-numeric() 
   for(i in 1:length(lprot)) {
      ind1<-lprot[[i]]
      fish<-ecofisher.meth1(ind1,tab,f.p,df.p,model.info)
      somme<-somme+subjects[i]*Nbsubjects*fish 
   }
   sigmaslopen<-lapply(1:nr,function(nr,x) x[nr],x=paste("sig.slope",
     LETTERS[1:nr],sep=""))
   sigmaintern<-lapply(1:nr,function(nr,x) x[nr],x=paste("sig.inter",
     LETTERS[1:nr],sep=""))
   xv<-rbind(model.info$sigmainter,model.info$sigmaslope)
   xn<-rbind(sigmaintern,sigmaslopen)
   SIG<-unlist(c(xv))
  
   vec<-diag(model.info$omega)!=0 
   omega1<-as.matrix(model.info$omega[,vec])[vec,] 
#Matrice dj de la bonne dimension
   det<-det(somme)    #Fisher determinant
#det<-crit(criterion,somme,pp)
   if (det==0) crit<-1e-99   else crit<-(det)^(1/pp)     #dans le cas o le protocole est degenere
   invcrit<-1/crit 
      #print(invcrit)
   f<-fisher.cv(somme,pp,SIG[SIG!=0],omega1,model.info$beta)
   inv<-f[[1]]
   se<-f[[2]]
   cv<-f[[3]]
   l<-list(somme=somme,inv=inv,se=se,cv=cv,det=det,crit=crit,
     pp=pp,subjects=subjects,xn=xn,SIG=SIG)
   return(l)
}
############################################################################
####                        Generate the elementary protocols                ####
############################################################################
# Objectif : passer d'une combinatoire sur les temps de protocole  une
# combinatoire sur les indices de protocole

########################################
#Auxiliary functions to combine lists of protocols (several responses)
# Combine 2 protocols from different sampling windows
combn.protoc<-function(list1,list2) {
  list3<-list()
  ni<-1
  for(i in 1:length(list1)) {
    for(j in 1:length(list2)) {
       list3[[ni]]<-c(list1[[i]],list2[[j]])
       ni<-ni+1
    }
  }
  return(list3)
}
#Combine protocols for 2 responses, identical.times=F
combn.repo<-function(list1,list2,lirep,irep2) {
  list3<-list()
  lirep2<-list()
  ni<-1
  for(i in 1:length(list1)) {
    for(j in 1:length(list2)) {
       list3[[ni]]<-c(list1[[i]],list2[[j]])
       lirep2[[ni]]<-c(lirep[[i]],rep(irep2,length(list2[[j]])))
       ni<-ni+1
    }
  }
  return(list(protoc=list3,lirep=lirep2))
}
#Combine protocols for 2 responses, identical.times=T
combn.repo.idT<-function(list1,list2,lirep,irep2) {
  list3<-list()
  lirep2<-list()
  for(i in 1:length(list1)) {
       list3[[i]]<-c(list1[[i]],list2[[i]])
       lirep2[[i]]<-c(lirep[[i]],rep(irep2,length(list2[[i]])))
  }
  return(list(protoc=list3,lirep=lirep2))
}

##################################################
#Collect information about sampling design
collect.sampling.info<-function(interactive=F,sampl.info,model.info) {        
   ipb<-0
   nr<-model.info$nr
   #length(unlist(lapply(1:nr, function(nr,nwind)!is.numeric(nwind[[nr]]),nwind=nwind))==T)==0
   if(length(unlist(lapply(1:nr,function(nr,nwind) !is.numeric(nwind[[nr]]),
      nwind=sampl.info$nwind))==T)==0) 
      {
      cat("Please give the number of separate","sampling windows available.\n")
      if (length(sampl.info$nwind)!=nr) 
        cat("nwind must be a list of the same size as the number of responses")
      ipb<-1
      nwind<-0
   } else { 
      vnsamp<-lapply(1:nr,function(nr,nsamp=nsamp,nwind=nwind) 
        c(nwind[[nr]]==length(nsamp[[nr]])),nsamp=sampl.info$nsamp,nwind=sampl.info$nwind)  
      if((length(unlist(lapply(1:nr,function(nr,nsamp)!is.numeric(nsamp[[nr]]),
        nsamp=sampl.info$nsamp))==T)==0)||(all(unlist(vnsamp))!=T)) {
          cat("Please give","the number of points to be taken in each sampling window.\n",
           "This must be a list with one vector for each window \n",
           "If the vector has several values, elementary protocols with different",
           "number of points will be generated. \n")
           ipb<-1
           }
      vsampwin<-lapply(1:nr,function(nr,sampwin,nwind) 
       c(nwind[[nr]]==length(sampwin[[nr]])),sampwin=sampl.info$sampwin,
       nwind=sampl.info$nwind)
      if((length(unlist(lapply(1:nr,function(nr,sampwin)
       !is.numeric(sampwin[[nr]]),sampwin=sampl.info$sampwin))==T)==0) ||
       (all(unlist(vsampwin))!=T)) {
        cat("Please give the sampling points for each sampling window.\n",
        "This must be a list with one vector of values for each window\n")
        ipb<-1
      }

      if((length(unlist(lapply(1:nr, function(nr,nmaxpts)
        !is.numeric(nmaxpts[[nr]]),nmaxpts=sampl.info$nmaxpts))==T)==0)) {
        cat("Please give the maximum total",
        "number of points per elementary protocol.\n")
        ipb<-1
      }

      if((length(unlist(lapply(1:nr, function(nr,nminpts)
        !is.numeric(nminpts[[nr]]),nminpts=sampl.info$nminpts))==T)==0)) {
         cat("No minimum total number of points per elementary protocol given,",
           "assuming for the first response",sampl.info$nminpts,".\n",
           "etc","\n")
            ipb<-1
      }
       
      t<-sapply(sampl.info$nsamp,length)
      mgf<-lapply(1:nr,function(nr,t,nsamp) lapply(1:(t[nr]),
        function(t,nsamp) max(nsamp[[nr]][[t]]),nsamp=nsamp),nsamp=sampl.info$nsamp,t=t)
#nmax par reponse
      nmgf<-lapply(1:nr,function(nr,mgf) sum(unlist(mgf[[nr]])),mgf=mgf)
      if (all(unlist(nmgf)==unlist(sampl.info$nmaxpts))!=T){
        cat("nmaxpts is not consistent with the nsamp for one response \n")
        ipb<-1
      }
#nminpts
      migf<-lapply(1:nr,function(nr,t,nsamp) lapply(1:(t[nr]),
        function(t,nsamp) min(nsamp[[nr]][[t]]),nsamp=nsamp),nsamp=sampl.info$nsamp,t=t)
      nmigf<-lapply(1:nr,function(nr,migf) sum(unlist(migf[[nr]])),migf=migf)
      if (all(unlist(nmigf)==unlist(sampl.info$nminpts))!=T) {
        cat("nminpts is not consistent with the nsamp for one response \n")
        ipb<-1}        
      }
      if(ipb==1) return(list(ipb=1))

#print the input
   cat("----------------------------------------------------------------\n")
   cat("            SUMMARY OF THE SAMPLING INFORMATION \n")
   cat("----------------------------------------------------------------\n")
   for ( l in 1: nr){
     cat("Sampling windows for the response:",LETTERS[l],"\n")
     for (i in 1:sampl.info$nwind[[l]]) {
       cat("Window",i,": t=",sampl.info$sampwin[[l]][[i]],"\n")
       cat("              Nb of sampling points to be taken in this window, n[",
       i,"]=",sampl.info$nsamp[[l]][[i]],"\n") }
       if(is.na(sampl.info$nmaxpts[[l]])) {
         sampl.info$nmaxpts[[l]]<-sum(unlist(lapply(sampl.info$nsamp[[l]],max)))
         cat("Computing the maximum number of points per protocol.\n")}
       cat("Maximum total number of points in one elementary protocol :",
         sampl.info$nmaxpts[[l]],"\n")
       if(is.na(sampl.info$nminpts[[l]])) {
         sampl.info$nminpts[[l]]<-sum(unlist(lapply(sampl.info$nsamp[[l]],min)))
         cat("Computing the minimum number of points per protocol.\n")}
       cat("Minimum total number of points in one elementary protocol :",sampl.info$nminpts[[l]],"\n")
       cat("----------------------------------------------------------------\n")
   }
   return(list(ipb=0,sampl.info=sampl.info))
}

##########################################
# Function to generate elementary protocols, simplified (no second derivatives)
generate.multprot.meth1<-function(filename="matelem.tmp",interactive=F,
 model.info,struc.info,sampl.info,init.info) {
   cat("Computing model and first derivative values for all possible times.\n")
   cat("This may take a while depending on the complexity of the model.\n")
#create table with all protocol times
   tim.dos<-create.timdos(model.info,struc.info,sampl.info,init.info)
# compute first derivatives
   if(struc.info$modelform=="AF") {
     y<-symbolic.prem(model.info,struc.info,sort(unique(tim.dos$iform)))
     df.forms<-y[[1]]
# compute model and derivative values for all sampling times
     y2<-calc.modelprem(tim.dos,model.info,struc.info,df.forms)
     f.p<-y2[[1]]
     df.p<-y2[[2]]
   } else {
#Compute model predictions and first derivatives
# when model is described by differential equations
     y2<-calc.model.de(tim.dos,model.info,init.info,struc.info)
     f.p<-y2[[1]]
     df.p<-y2[[2]]
   }

#collect information 
  ipb<-collect.sampling.info(F,sampl.info,model.info)
  if (ipb[[1]]==1) return(list(ipb=1))
  sampl.info<-ipb$sampl.info
#Generate all possible protocols
  listprot<-list()
# creation d'un vecteur avec les indices au lieu des temps
  indwin<-sampl.info$sampwin
  iwin<-sampl.info$sampwin
  lwin<-iwin
  for(i in 1:length(indwin))
     lwin[[i]]<-lapply(iwin[[i]],function(vec,irep,idos) paste(vec,irep,idos,
     sep="x"),irep=i,idos=1)
  for(i in 1:length(indwin))
     indwin[[i]]<-lapply(lwin[[i]],function(vec) match(vec,tim.dos$id))
  nr<-model.info$nr

#liste des protocoles combins : list.cbn
#liste des protocoles possibles pour toutes les rponses
#liste de mme taille avec la rponse correspondante : list.rep
#Generate the list for the first dose
  list.nr<-list() 
  if(sampl.info$identical.times) {#how many possible times
    nl<-dim(tim.dos[tim.dos$irep==1 & tim.dos$condnum==tim.dos$condnum[1],])[1]
  }
  for(l in 1:nr) {
    if(sampl.info$identical.times & l>1) {
      list.nr[[l]]<-lapply(list.nr[[1]],function(vec) vec+nl*(l-1))
    } else {
#generate all possible protocols for each sampling window
    list1<-list()
    for(ik in 1:sampl.info$nwind[[l]]) {      #number of windows of sampling times
      np1<-0
      list1[[ik]]<-list()
      for(ij in 1:length(sampl.info$nsamp[[l]][[ik]]))  {  #number of sampling times for the design
        iprotoc<-t(combn(indwin[[l]][[ik]],sampl.info$nsamp[[l]][[ik]][ij]))
        nprot<-dim(iprotoc)[1]
        l1<-lapply(1:nprot,function(i,vec) vec[i,],vec=iprotoc)
        for(i in 1:nprot) list1[[ik]][[i+np1]]<-l1[[i]]
        np1<-np1+nprot
      }#fin boucle sur le nombre de prelevements possibles dans chaque fenetre
    }#fin boucle sur le nombre de fenetres
#generate all possible protocols for each sampling window
    if(length(list1)>1) {
      list3<-list1[[1]]
      for(i in 2:length(list1)) {
        list3<-combn.protoc(list3,list1[[i]])
      }
      list1<-list3
    } else list1<-list1[[1]]
#prune protocols to respect the min/max nb of samples
    lprot<-unlist(lapply(list1,length))
    nmin<-sampl.info$nminpts[[l]];nmax<-sampl.info$nmaxpts[[l]];n1<-0
    list2<-list()
    for(i in 1:length(list1)) {
      if((lprot[i]-nmin)*(lprot[i]-nmax)<=0) {
        n1<-n1+1
        list2[[n1]]<-list1[[i]]
        }
     }
    list1<-list2
    list.nr[[l]]<-list1
    } #end loop on identical.times
  } #end loop on number of responses
#If several responses, combine the responses
  list.rep<-lapply(1:length(list.nr[[1]]),
     function(i,lis) rep(1,length(lis[[i]])),lis=list.nr[[1]])
  if(nr>1) {
    list1<-list.nr[[1]]
    if(sampl.info$identical.times) {
       for(j in 2:nr) {
          list.cb<-combn.repo.idT(list1,list.nr[[j]],list.rep,j)
          list1<-list.cb[[1]]
          list.rep<-list.cb[[2]]
       }
       list.cbn<-list1
    } else {
       for(j in 2:nr) {
          list.cb<-combn.repo(list1,list.nr[[j]],list.rep,j)
          list1<-list.cb[[1]]
          list.rep<-list.cb[[2]]
       }
       list.cbn<-list1
    }
  } else list.cbn<-list.nr[[1]]

#Duplicating the list for several doses
   if(struc.info$modelform=="AF") {
     if(!init.info$dose.identical & length(init.info$doses)>1) {
       len1<-length(list.cbn)
       l2<-list.cbn
       l3<-list.rep
       nl<-dim(tim.dos[tim.dos$doses==init.info$doses[1],])[1]
       for(idos in 2:length(init.info$doses)) {
         l1<-lapply(list.cbn,function(vec) vec+(idos-1)*nl)
         for(i in 1:length(l1)) {
           l2[[(i+len1)]]<-l1[[i]]
           l3[[(i+len1)]]<-list.rep[[i]]
           }
         len1<-len1+length(l1)
         }
       list.cbn<-l2
       list.rep<-l3
     }
   } else { #cas DE
     if(!init.info$condinit.identical & length(init.info$condinit)>1) {
       len1<-length(list.cbn)
       l2<-list.cbn
       l3<-list.rep
       nl<-dim(tim.dos[tim.dos$condnum==tim.dos$condnum[1],])[1]
       for(idos in 2:length(init.info$condinit)) {
         l1<-lapply(list.cbn,function(vec) vec+(idos-1)*nl)
         for(i in 1:length(l1)) {
           l2[[(i+len1)]]<-l1[[i]]
           l3[[(i+len1)]]<-list.rep[[i]]
           }
         len1<-len1+length(l1)
         }
       list.cbn<-l2
       list.rep<-l3
     }
   }
   
    cat("Now evaluating the Fisher Information Matrix for the",length(list.cbn),
    "protocols generated \n")
    cat(" This may take a while depending on the number of protocols.\n",
    " Please wait for the program to write the matrices in a file.\n")
#   print(df.p)

#Compute the Fisher information matrix for each protocol
  lamb<-c(diag(model.info$omega))
  for(l in 1:nr)
    lamb<-c(lamb,model.info$sigmainter[[l]],model.info$sigmaslope[[l]])
  nullpar<-which(lamb==0)
  model.info$nullpar<-nullpar
  lfish<-list()
  tprot<-list()
  lk<-0
  for(kprot in 1:length(list.cbn)) {
    print(kprot)
    protk<-list.cbn[[kprot]]
    repk<-list.rep[[kprot]]
    tprot[[kprot]]<-tim.dos$times[list.cbn[[kprot]]]
    y<-try(ecofisher.meth1(protk,tim.dos,f.p,df.p,model.info))
    if(mode(y)=="character") {
       lfish[[kprot]]<-NULL 
#       cat("Pb in the computation of the Fisher information matrix for protocol",
#       kprot,"\n")
       lk<-1
     } else
       lfish[[kprot]]<-y
#     if(kprot==1 | kprot==79) {
#        cat("kprot=",kprot,"\n");print(protk)
#        print(f.p);print(df.p)
#        print(lfish[[kprot]])
#     }  
  }
#Save to files
  if(lk>0) { #remove NULL protocols
    ik<-1
    lis1<-tp1<-lfi1<-lrep1<-list()
    for(k in 1:length(list.cbn)) {
      if(!is.null(lfish[[k]])) {
        lis1[[ik]]<-list.cbn[[k]]
        tp1[[ik]]<-tprot[[k]]
        lfi1[[ik]]<-lfish[[k]]
        lrep1[[ik]]<-list.rep[[k]]
        ik<-ik+1
      }
    }
   list.cbn<-lis1
   tprot<-tp1
   lfish<-lfi1
   list.rep<-lrep1
  }
  for(k in 1:length(list.cbn)) {
      write(k,filename,append=k>1)
      write(length(list.cbn[[k]]),filename,append=T)
      write(tim.dos[list.cbn[[k]],2],filename,ncol=length(list.cbn[[k]]),append=T)
      write.table(lfish[[k]],filename,col.names=F,row.names=F,quote=F,append=T)
  }
  return(list(ipb=0,protoc=list.cbn,tprotoc=tprot,fisher=lfish,
    sampl.info=sampl.info,tab=tim.dos,f.p=f.p,df.p=df.p,nullpar=nullpar,
    list.rep=list.rep,model.info=model.info))
}

#FW under steroids
fedorov.wynn.sg<-function(interactive=F,
 fileres=paste(directory,"details.r",sep=dirsep),
 filematelem=paste(directory,"matelem.tmp",sep=dirsep),
 model.info,struc.info,sampl.info,init.info) {
   nr<-model.info$nr
   prots<-init.info$prots
#Generate matelem.tmp or collect sampling information
   ipb<-generate.multprot.meth1(filematelem,interactive,model.info=model.info,
   struc.info=struc.info,sampl.info=sampl.info,init.info=init.info)
#Information to be passed on (including modified structures)
   tab=ipb$tab;f.p=ipb$f.p;df.p=ipb$df.p;nullpar=ipb$nullpar
   model.info<-ipb$model.info;sampl.info<-ipb$sampl.info
   list.rep<-ipb$list.rep
   protoc<-ipb$protoc
   dimsig<-lapply(1:nr,function(nr,sigmainter,sigmaslope) 
     sum(as.integer(unlist(sigmainter[[nr]])>0)+as.integer(unlist(sigmaslope[[nr]])>0)),
     sigmainter=model.info$sigmainter,sigmaslope=model.info$sigmaslope)
   ndim<-length(model.info$beta)+sum(as.integer(model.info$omega>0))+sum(unlist(dimsig))
#Transform initial protocols in indices on tab elements
   initnp<-length(prots[[1]])
   iprot<-prots
   if(struc.info$modelform=="AF") {
     dprot<-match(init.info$doses,unique(init.info$doses))
     if(length(dprot)<initnp) #recycle doses
        dprot<-rep(dprot,initnp)
   } else {
     dprot<-c(1:length(init.info$condinit))
     if(length(init.info$condinit)<initnp) #recycle doses
        dprot<-rep(dprot,initnp)
   }
   for(l in 1:nr) {
     for(i in 1:length(iprot[[l]])) {
      iprot[[l]][[i]]<-unlist(lapply(iprot[[l]][[i]],function(t,tab,icond,l) 
      which((tab$times==t & tab$condnum==icond & tab$irep==l)),tab=tab,
      icond=dprot[i],l=l))
     }
   }
#if several responses, combine the protocols to create the initial protocols
   if(nr>1) {
      initindx<-inittps<-list()
      for(i in 1:length(iprot[[1]])) {
        vec<-vec2<-c()
        for(l in 1:nr) {
          vec<-c(vec,iprot[[l]][[i]])
          vec2<-c(vec2,prots[[l]][[i]])
        }
        initindx[[i]]<-vec
        inittps[[i]]<-vec2
      }
   } else {
      initindx<-iprot[[1]]
      inittps<-prots[[1]]
   }

#Running Fedorov
   datprob<-list(filematelem,fileres,initindx,init.info$subjects,inittps)      
   yini<-fedorov.init(datprob,ndim,protoc,tab,init.info)
#print("federovinit")
#   if(yini$ipb==1) return(list(ipb=1)) #now affects 1st protocol if pb
   init.np<-yini$zeprot[1]
   init.freq<-yini$freq
   init.num<-yini$zeprot[2:(init.np+1)]
# garder les conditions d'initialisations
   init.fed<-list(init.np=init.np,init.freq=init.freq[1:init.np],init.num=init.num)
   data.fed<-list(tab=tab,f.p=f.p,df.p=df.p,nullpar=nullpar)
   protoc.fed<-list(protoc=protoc,tprotoc=ipb$tprotoc)

   yfed.inp<-list(namfich=yini$namfich,ndimen=yini$ndimen,zeprot=yini$zeprot,
   freq=yini$freq,datprob=datprob,protoc=protoc,tprotoc=ipb$tprotoc)
   yfed<-fedorov.alg(yfed.inp)
#note : protopti, protfreq, nq returned by yfed never used...
   np.f<-yfed$y[[3]]
   opti.fed<-list(opti.np=np.f,opti.freq=yfed$protfreq[1:np.f],
      opti.num=yfed$y[[4]][1:np.f],opti.tps=yfed$protopti)
# print(list(ipb=0,yfed=yfed,protopti=yfed$protopti,protfreq=yfed$protfreq))
   return(list(ipb=0,yfed=yfed,protopti=yfed$protopti,protfreq=yfed$protfreq,
   protoc.fed=protoc.fed,init.fed=init.fed,data.fed=data.fed,opti.fed=opti.fed,
   sampl.info=sampl.info,model.info=model.info))
}

##############################################################################
#Fonction pour faire tourner Fedorov avec initialisation
fedorov.init<-function(datprob,ndim,protoc,tab,init.info) {
#datprob[[1]]--[[2]] :2 chaines de caractres
# datprob[[3]]: index des tps pour chaque protocole (selon tab)
# datprob[[4]]: le vecteur de frquences
# datprob[[5]]: tps pour chaque protocole
   namfich<-c(datprob[[1]],datprob[[2]])
   vectps<-rep(0,ndim*4);
   fisher<-rep(0,ndim*(ndim+1)/2)
#Protocoles lementaires constituant le protocole de population initial
   initindx<-datprob[[3]] 
   zefreq<-datprob[[4]]
   freq<-rep(0,ndim*2)
   inittps<-datprob[[5]]
   ndimen<-c(length(protoc),ndim,init.info$cost)
# dterminer quels sont les protocoles initiaux => idx.initprot
   idx.initprot<-c()
   for(i in 1:length(initindx)) {
     vec<-unlist(lapply(protoc,function(v1,vec) identical(as.integer(v1),vec),
        vec=as.integer(initindx[[i]])))
     idx.initprot<-c(idx.initprot,which(vec)[1])
   }
   kna<-which(is.na(idx.initprot))
   if(length(kna)>0) {
     for(i in kna)
        cat("Initial protocol",inittps[[i]],
        "does not correspond to the constraints, discarding it.\n")
   }
   kdup<-which(!is.na(idx.initprot) & duplicated(idx.initprot))
   if(length(kdup)>0) {
     for(i in kdup)
        cat("You have entered initial protocol",inittps[[i]],
        "more than one time, collapsing identical protocols in the input.\n")
   }
   kprot<-unique(idx.initprot[!is.na(idx.initprot)])
   if(length(kprot)==0) {
     cat("The initial protocols are not correctly specified.\n")
     cat("They must correspond to protocols possible given the constraints on time in the sampling windows.\n")
     cat("Replacing initial protocol by the first possible protocol\n")
     kprot<-c(1)
     zefreq<-c(1)
     cat("Protocol",kprot," times=",tab$times[protoc[[kprot]]],"\n")
     ipb<-1
   } else {
     ipb<-0
     idx.initprot[is.na(idx.initprot)]<-0
     for(ip in 1:length(kprot))
       freq[ip]<-sum(zefreq[kprot[ip]==idx.initprot])
     if(sum(freq)!=1) {
       cat("Standardising the frequencies of the initial protocols to a sum of 1.\n")
       xcal<-sum(freq)
       freq<-freq/xcal
     }
   }
   zeprot<-c(length(kprot),kprot,rep(0,(ndim*2-length(kprot))))
   cat(zeprot[1],"initial elementary protocols:",zeprot[2:(1+length(kprot))],"\n")
   cat("Frequencies:",freq[1:length(kprot)],"\n")
   cat("Dimensions of the problem:",ndimen,"\n")
   yli<-list(ipb=ipb,namfich=namfich,ndimen=ndimen,zeprot=zeprot,freq=freq)
   return(yli)
}

fedorov.alg<-function(inputcheck) {
#inputcheck:liste de 2 chaines de caractres, un entier, une liste de vecteurs
#de temps, et un vecteur de frquences
   cat("inputcheck=")
   #print(inputcheck)
   namfich<-inputcheck[[1]] #fichiers matelem et rsultats
   ndimen<-inputcheck[[2]] #dimensions du pb (nb prot elem, ndim, cout)
   zeprot<-inputcheck[[3]] #nb puis numros des protocoles lmentaires ds prot init
   zefreq<-inputcheck[[4]] #frquences protocoles lmentaires
   datprob<-inputcheck[[5]]
   protoc<-inputcheck[[6]]
   tprotoc<-inputcheck[[7]]
   np.init<-zeprot[1] #nb de protocoles lmentaires ds protocole initial
   ndim<-ndimen[2]
#Dimensionnement des vecteurs
   numprot<-rep(0,ndim*2);
   nbdata<-numprot;
   freq<-numprot
   vectps<-rep(0,length(numprot)*max(unlist(lapply(protoc,length))));
   fisher<-rep(0,ndim*(ndim+1)/2)
   nok<-0
   cat("----------------------------------------------------------------\n")
   cat("Initial protocol\n")
   cat("----------------------------------------------------------------\n")
   cat("NUMBER OF GROUPS   ",np.init,"\n")
   cat("   Freq.   Protocol nb       Times       \n")
   for(i in 1:np.init) {
      cat(i,".   ",format(zefreq[i],width=5),"    ",format(zeprot[i+1],width=5),
        "           ")
      cat(tprotoc[[zeprot[[i+1]]]],"\n")
   }
   cat("\n")
   cat("----------------------------------------------------------------\n")
   
   y<-.C("FedorovInit_R",as.character(namfich),as.integer(ndimen),
   as.integer(np.init),as.integer(numprot),as.double(freq),as.integer(nbdata),
   as.double(vectps),as.double(fisher),as.integer(nok),as.integer(zeprot),
   as.double(zefreq))
   if(y[[9]]>=0){ #Test si l'optimisation s'est bien passe
     cat("----------------------------------------------------------------\n")
     cat("Optimisation results\n",y[[9]]," iterations \n")
     cat("----------------------------------------------------------------\n")
     cat("NUMBER OF GROUPS   ",y[[3]],"\n")
     cat("   Freq.   Protocol nb       Times       \n")
     ij<-1
     for(i in 1:y[[3]]) {
       cat(i,".   ",format(y[[5]][i],width=5),"    ",format(y[[4]][i],width=5),
       "           ")
       for(j in 1:y[[6]][i]) {
         cat(format(y[[7]][ij],width=5)," ")
         ij<-ij+1
       }
       cat("\n")
     }
     cat("----------------------------------------------------------------\n")
     nq<-c(y[[6]][1:y[[3]]])
     protopti<-vector(y[[3]],mode="list")
     protfreq<-y[[5]][1:y[[3]]]
     n1<-1
     for(i in 1:y[[3]]) {
       protopti[[i]]<-c(y[[7]][n1:(n1+y[[6]][i]-1)])
       n1<-n1+y[[6]][i]
     }
     if(y[[9]]==0) {
       cat("The program has returned after 0 iterations.\n")
       cat("It is possible that the initial population protocol was optimal,\n")
       cat("but if any other error message appeared it is more likely\n")
       cat("that it was too poor for the program to be able to start.\n")
       cat("We suggest running PFIM again after adding more protocols to\n")
       cat("the initial population protocol.\n")
     }
     return(list(y=y,protopti=protopti,protfreq=protfreq,nq=nq))
   } else 
     return(y=y) # Problem in optimisation
}


###########################################################################
###                          Function for graph                          ###                                                                                                  #                                                             
###########################################################################

#function to build graph, model in analytical form
graph.fw.af<-function(gr.tps,gr.list,tab,icond,graph.info,struc.info,model.info,
  init.info) {
   p<-length(model.info$beta)
   nr<-model.info$nr
   
   for (i in 1:p) 
      assign(parameters[i],model.info$beta[i])
   graphinf<-graph.info$graphinf
   graphsup<-graph.info$graphsup
   tt1<-list()
   #tt<-lapply(1:nr,function(nr,graphinf,graphsup) seq(graphinf,graphsup,0.1),graphinf<-graphinf[[nr]],graphsup<-graphsup[[nr]])   
     for (l in 1:nr){
       tt1[[l]]<-list()
       if (length(struc.info$bound[[l]])==1){
         if( struc.info$bound[[l]][[1]][1]> graphsup[[l]]) {
            warning(" The upper limit for the graph  ",l,
              "  is too small, cannot draw graph \n")
           return(0)
         }
         tt1[[l]][[1]]<-c(struc.info$bound[[l]][[1]][1]:graphsup[[l]])
       } else {
       for (i in 1: (length(struc.info$bound[[l]])-1)){
          tt1[[l]][[i]]<-c(struc.info$bound[[l]][[i]][1]:struc.info$bound[[l]][[i]][2])
          if(i==length(struc.info$bound[[l]])-1){
             if (struc.info$bound[[l]][[i]][2]>graphsup[[l]]) {
                warning(" The upper limit (graph.sup)  for the response  ",
                 LETTERS[ l],"  is too small")
             return(0)
              }
             tt1[[l]][[i+1]]<-c(struc.info$bound[[l]][[i]][2]:graphsup[[l]])
          }
       }
     }
    }
   tt1b<-lapply(1:nr,function(nr,tt1) unlist(tt1[[nr]]),tt1<-tt1)
   tt1<-lapply(1:nr,function(nr,tt1b) tt1b[[nr]][tt1b[[nr]]>=graphinf[[nr]][1] & tt1b[[1]]<=graphsup[[nr]][1]],tt1b<-tt1b) 
   ff1<-list()
   if ((init.info$dose.identical==T) | length(unique(icond))==1) {
     idos<-which(c(1:length(init.info$doses))==icond[1])
     dose<-init.info$doses[icond[1]] 
     par(mfrow=c(1,nr))
     for (l in 1:nr){
        ff1[[l]]<-vector(mode="numeric", length(tt1[[l]]))
        for (j in 1:length(tt1[[l]])) {
          t<-tt1[[l]][j]
          ff1[[l]][j]<-eval(struc.info$formg[[(l+nr*(idos-1))]][t<=struc.info$tf[[l]]][1])
        }
        if(graph.info$log.logical!=F) 
          plot(tt1[[l]],ff1[[l]],type='l',xlab='Time',ylab=paste(graph.info$names.data[l]),
            log=graph.info$log.logical,ylim=c(y.range,range(ff1[[l]]))[1:2]) else 
          plot(tt1[[l]],ff1[[l]],type='l',xlab='Time',ylab=paste(graph.info$names.data[l]),
            ylim=c(y.range,range(ff1[[l]]))[1:2])
      #points for the design on the graph
        for (i in 1:length(gr.tps)) {
           tps<-gr.tps[[i]][gr.list[[i]]==l]
           tab1<-tab[tab$irep==l & tab$condnum==icond[1],]
           f.tps<-tab1$f.p[match(tps,tab1$times)]
           points(tps,f.tps,pch=paste(i),cex=2,col=paste(i))
        }
        title(paste(graph.info$names.data[l],"model ","\n Dose = ",
          dose,sep=" "))
      }
   } else {
#Regroup doses
     uni.cond<-sort(unique(icond))
     par(mfrow=c(length(uni.cond),nr))
     for(kd in 1:length(uni.cond)) {
#       dose<-doses[unique(icond)[kd]]
       idos<-which(c(1:length(init.info$doses))==uni.cond[kd])
       dose<-init.info$doses[uni.cond[kd]]
       for (l in 1:nr){
          ff1[[l]]<-vector(mode="numeric", length(tt1[[l]]))
          for (j in 1:length(tt1[[l]])) {
            t<-tt1[[l]][j]
            ff1[[l]][j]<-eval(struc.info$formg[[(l+nr*(idos-1))]][t<=struc.info$tf[[l]]][1])
          }
          if(graph.info$log.logical!=F) 
         plot(tt1[[l]],ff1[[l]],type='l',xlab='Time',ylab=paste(graph.info$names.data[l]),
            log=graph.info$log.logical,ylim=c(y.range,range(ff1[[l]]))[1:2]) else 
         plot(tt1[[l]],ff1[[l]],type='l',xlab='Time',ylab=paste(graph.info$names.data[l]),
            ylim=c(y.range,range(ff1[[l]]))[1:2])
      #points for the design on the graph
          for(k in which(icond==uni.cond[kd])) {
            tps<-gr.tps[[k]][gr.list[[k]]==l]
            tab1<-tab[tab$irep==l & tab$condnum==icond[k],]
            f.tps<-tab1$f.p[match(tps,tab1$times)]
            points(tps,f.tps,pch=paste(k),cex=2,col=paste(k))
          }
          title(paste(graph.info$names.data[l],"model ","\n Dose = ",
           init.info$doses[uni.cond[kd]],sep=" "))
       }
     }
   }
}

#function to build graph, model described by differential equations
graph.fw.de<-function(gr.tps,gr.list,tab,icond,graph.info,struc.info,model.info,
  init.info) {
   p<-length(model.info$beta)
   formED<-struc.info$formED
   nr<-model.info$nr
   for (i in 1:p) 
      assign(parameters[i],model.info$beta[i])
   graphinf<-graph.info$graphinf
   graphsup<-graph.info$graphsup
   
   tt<-list()
   ff1<-list()
   e<-list()
   e1<-list()
   tt<-lapply(1:nr, function(nr,graphinf,graphsup) seq(graphinf[[nr]],
     graphsup[[nr]],0.1),graphinf=graphinf,graphsup=graphsup)
   if (init.info$condinit.identical==T | length(unique(icond))==1) {
     par(mfrow=c(1,nr))
     cond<-eval(init.info$condinit[icond[1]])
     e<-lapply(1:nr,function(nr,time.condinit,tt) c(time.condinit,tt[[nr]]),
       time.condinit=init.info$time.condinit,tt=tt)
     for (li in 1:nr){
        ff1[[li]]<-lsoda(cond,e[[li]],formED,beta,rtol=RtolEQ,atol=AtolEQ,hmax=Hmax)
        if (nr==1) ff1[[li]]<-ff1[[li]][,dim(ff1[[li]])[2]] [-1]
        else  ff1[[li]]<-ff1[[li]][,((dim(ff1[[li]])[2]-nr+1):(dim(ff1[[li]])[2]))][,li] [-1]
     }
     for (l in 1:nr){
        if (graph.info$log.logical!=F) 
          plot(tt[[l]],ff1[[l]],type='l',xlab='time',ylab=paste(graph.info$names.data[l]),
            log=graph.info$log.logical,ylim=c(y.range,range(ff1[[l]]))[1:2]) else 
          plot(tt[[l]],ff1[[l]],type='l',xlab='time',ylab=paste(graph.info$names.data[l]),
             ylim=c(y.range,range(ff1[[l]]))[1:2])
        for (i in 1:length(gr.tps)) {
           tps<-gr.tps[[i]][gr.list[[i]]==l]
           tab1<-tab[tab$irep==l & tab$condnum==icond[1],]
           f.tps<-tab1$f.p[match(tps,tab1$times)]
           points(tps,f.tps,pch=paste(i),cex=2,col=paste(i))
        }
        title(paste(graph.info$names.data[l],"model ","\n Initial Conditions = ",
          init.info$condinit[icond[1]],sep=" "))
     }
   } else {
#Regroup doses
     par(mfrow=c(length(unique(icond)),nr))
     for(kd in 1:length(unique(icond))) {
       cond<-eval(init.info$condinit[unique(icond)[kd]])
        e<-lapply(1:nr,function(nr,time.condinit,tt) c(time.condinit,
          tt[[nr]]),time.condinit=init.info$time.condinit,tt=tt)
        ff1<-list()
        for (li in 1 : nr) {
          ff1[[li]]<-lsoda(cond,e[[li]],formED,beta,rtol=RtolEQ,atol=AtolEQ,hmax=Hmax)
          if (nr==1) ff1[[li]]<-ff1[[li]][,dim(ff1[[li]])[2]] [-1]
          else 
            ff1[[li]]<-ff1[[li]][,((dim(ff1[[li]])[2]-nr+1):(dim(ff1[[li]])[2]))][,li] [-1]
        }
        for (l in 1:nr){
          if (graph.info$log.logical!=F) 
         plot(tt[[l]],ff1[[l]],type='l',xlab='time',ylab=paste(graph.info$names.data[l]),
            log=graph.info$log.logical,ylim=c(y.range,range(ff1[[l]]))[1:2]) else 
         plot(tt[[l]],ff1[[l]],type='l',xlab='time',ylab=paste(graph.info$names.data[l]),
             ylim=c(y.range,range(ff1[[l]]))[1:2])
          for(k in which(icond==unique(icond)[kd])) {
            tps<-gr.tps[[k]][gr.list[[k]]==l]
            tab1<-tab[tab$irep==l & tab$condnum==icond[k],]
            f.tps<-tab1$f.p[match(tps,tab1$times)]
            points(tps,f.tps,pch=paste(k),cex=2,col=paste(k))
          }
          title(paste(graph.info$names.data[l],"model ","\n Initial Conditions = ",
            init.info$condinit[unique(icond)[kd]],sep=" "))
        }
      }
   }
}

###########################################################################
###                                 Fedorov output                                ###                                                                                                  #                                                             
###########################################################################
out.fedorov<-function(modelfile="Stdin.r",directory=".",
directory.program=".") {  
#directories  
#directory : control file ("Stdin.r"), models and results
#directory.program : FW library, model library, and this program
##############################
#precomputation
   options(expressions=5000)  
   d<-Sys.time()
   g<-proc.time()
   under.unix<-!(version$os=='Microsoft Windows' ||
      version$os=='Win32' || version$os=='mingw32')
   #cat("Directory for PFIM3.0 programs:",directory.program,"\n")
   #cat("Directory for project:",directory,"\n")
#Global variables
   assign("dirsep",ifelse(under.unix,"/","\\"),env = .GlobalEnv)
   assign("directory",directory,env = .GlobalEnv)
   assign("directory.program",directory.program,env = .GlobalEnv)
   source(paste(directory,dirsep,modelfile,sep=""))
   modfile<-paste(directory,file.model,sep=dirsep)

#Loading libraries and Fedorov-Wynn
   require("combinat")
   require(odesolve)
   require(nlme)

   if(!is.loaded("FedorovInit_R")) {
      if(under.unix) {
         namlib<-"libFED.so";namdir<-paste(directory.program,dirsep,sep="")
         cmd<-paste("R CMD SHLIB -o ",namdir,namlib,"  ",namdir,"initfedoR.c",sep="")
         system(cmd)
         dyn.load(paste(namdir,namlib,sep=""))
      } else
         dyn.load(paste(directory.program,dirsep,"libFED.dll",sep=""))
   }

#Common for models in analytical form or differential equations
   doses<-NULL
   p<-length(beta)
   sigmainter<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("sig.inter",LETTERS[1:nr],sep=""))
   sigmaslope<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("sig.slope",LETTERS[1:nr],sep=""))
#Default values
   if(!exists("identical.times")) identical.times<-F # or T???

#recover the inital protocols for all the models
   if(identical.times==T){
     prots<-lapply(1:nr,function(nr,x) get(x),x=paste("prot",LETTERS[1],sep=""))
   } else
     prots<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("prot",LETTERS[1:nr],sep=""))
#if several responses, check that the same nb of protocols are specified for
# each response
   if(nr>1) {
     if(length(unique(unlist(lapply(prots,length))))>1)
       stop("You must specify the same number of initial protocols for each response.\n")
   }
   ll<-lapply(prots,length)

#For models in analytical form
   if(modelform=="AF") {
#Problem with multiple doses
      prot.dose<-dose #doses associated to each initial protocol
      doses<-sort(unique(dose)) # nb of possible doses
      assign("dose",doses[1],env=.GlobalEnv)
      dose<-doses[1]
      source(modfile,local=T)
      lf<-length(form) #nombre de forme analytique
#nombre de form dans chaque rponse pour savoir quoi prendre en tf
      formg<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("form",LETTERS[1:nr],sep=""))  #sous forme de list
      lformg<-lapply(formg,length)  #length(of each model tf or not)
      lf<-sum(unlist(lformg)) #vir car inutile ?: c(0,cumsum(lformg))
      form<-form[1:lf]
      if(length(doses)>1) {
        eco.form1<-form
        for(idos in 2:length(doses)) {
          assign("dose",doses[idos],env=.GlobalEnv)
           dose<-doses[idos] #seems to need both???
          source(modfile,local=T)
          for(ilf in 1:lf)
            eco.form1[[(ilf+(idos-1)*lf)]]<-form[[ilf]]
          eco.formg1<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("form",
            LETTERS[1:nr],sep=""))  #sous forme de list
          for(inr in 1:nr)
            formg[[(inr+nr*(idos-1))]]<-eco.formg1[[inr]]
        }
        form<-eco.form1
      }
      nform<-lf*length(doses)
#tests si toutes les bornes
      pres.b<-lapply(1:nr,function(nr,x) exists(x[nr]),
        x=paste("bound",LETTERS[1:nr],sep="")) 
      TF<-which(pres.b==F) 
      if(length(TF)==0) 
        bornes<-lapply(1:nr,function(nr,x) get(x[nr]),
          x=paste("bound",LETTERS[1:nr],sep="")) else {
        if(length(TF)==nr)  bornes<-rep(list(list(c(0,Inf))),nr) else { 
          bornes<-rep(list(list(c(0,Inf))),nr)
          for (i in 1:nr){ 
             if(length(which(TF==i))==0 ) {
               x=paste("bound",LETTERS[i],sep="")
               bornes[[i]]<-get(x)
             }
          }
        }
      }
#recover tf in order to compute the sensibility
      tf<-vector(mode="list")
      for (i in 1:length(lformg)){
        if (lformg[i]!=1){ 
          tf[[i]]<-vector()
          tf[[i]][1]<-bornes[[i]][[1]][2]
          for (j in 2:lformg[[i]])
             tf[[i]][j]<-c(bornes[[i]][[j]][2]) 
        } else tf[[i]]<-bornes[[i]][[1]][2]
      } 
      if (dose.identical==T) doses<-rep(prot.dose[1],length(prots[[1]])) else NULL
      condinit<-NULL
   } else { #for models described by differential equations
      source(modfile)
      if (condinit.identical==T) 
        condinit<-rep(condinit[1],length(prots[[1]]))
   }
                
   if (identical.times==T){
     nwind<-lapply(1:nr,function(nr,x) get(x),x=paste("nwind",LETTERS[1],sep=""))
     sampwin<-lapply(1:nr,function(nr,x) get(x),x=paste("sampwin",LETTERS[1],sep=""))
#sampwin<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("sampwin",LETTERS[1:nr],sep=""))
     nsamp<-lapply(1:nr,function(nr,x) get(x),x=paste("nsamp",LETTERS[1],sep=""))
     nmaxpts<-lapply(1:nr,function(nr,x) get(x),x=paste("nmaxpts",LETTERS[1],sep=""))
     nminpts<-lapply(1:nr,function(nr,x) get(x),x=paste("nminpts",LETTERS[1],sep=""))
   } else {
     nwind<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("nwind",
       LETTERS[1:nr],sep=""))
     sampwin<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("sampwin",
       LETTERS[1:nr],sep=""))
#sampwin<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("sampwin",LETTERS[1:nr],sep=""))
     nsamp<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("nsamp",
       LETTERS[1:nr],sep=""))
     nmaxpts<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("nmaxpts",
       LETTERS[1:nr],sep=""))
     nminpts<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("nminpts",
       LETTERS[1:nr],sep=""))
   }

   subjects.init<-subjects
   if (subjects.input==1) {
     l2<-lapply(prots,function(lis) lapply(lis,length))
     Nt<-lapply(1:nr, function(nr,subjects.init,l2) sum(subjects.init*unlist(l2[[nr]])),
       subjects.init=subjects.init,l2=l2)
     Ntot<-sum(unlist(Nt))
     subjects.total<-sum(subjects.init)
     subjects.init<-subjects.init/subjects.total
   }
   subjects<-subjects.init
 
 
   erro<-tryCatch(graphinf<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("graph.inf",LETTERS[1:nr],sep="")),error=function(e) 1)          
#e=0 si pas d'erreur et 1 sinon#
if (length(which(unlist(erro)==1))>=1)
{
vecg<-replicate(nr,0)
graphinf<- as.vector(vecg,mode="list")
graphsup<-lapply(1:nr,function(nr,x) max(unlist(get(x[nr]))),x=paste("prot",LETTERS[1:nr],sep=""))
} else
{
graphinf<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("graph.inf",LETTERS[1:nr],sep=""))
graphsup<-lapply(1:nr,function(nr,x) get(x[nr]),x=paste("graph.sup",LETTERS[1:nr],sep=""))
}


#Creating structures to pass information along to subroutines
#All info pertaining to the model parameters
   model.info<-list(beta=beta,omega=omega,nullpar=which(diag(omega)==0),
      sigmainter=sigmainter,sigmaslope=sigmaslope,nr=nr,Trand=Trand,
      parameters=parameters,names.data=names.data)
   if(modelform=="AF")
     struc.info<-list(modfile=modfile,modelform=modelform,form=form,lf=lf,
        formg=formg,lformg=lformg,tf=tf,bound=bornes) else
     struc.info<-list(modelform=modelform,formED=formED)
#All info pertaining to sampling
   sampl.info<-list(identical.times=identical.times,nwind=nwind,
     sampwin=sampwin,nsamp=nsamp,nmaxpts=nmaxpts,nminpts=nminpts)
#All info needed in graphs
   graph.info<-list(graph.logical=graph.logical,log.logical=log.logical,
      graphinf=graphinf,graphsup=graphsup,names.data=names.data,y.range=y.range)     
#All info pertaining to initial conditions, forms, etc...
   if(modelform=="AF")
     init.info<-list(dose.identical=dose.identical,doses=doses,
        prot.dose=prot.dose,prots=prots,subjects=subjects,cost=Ntot) else
     init.info<-list(condinit.identical=condinit.identical,condinit=condinit,
       prots=prots,subjects=subjects,cost=Ntot,
       time.condinit=time.condinit,RtolEQ=RtolEQ,AtolEQ=AtolEQ,Hmax=Hmax)

##############################
#Running Fedorov-Wynn
   fed<-fedorov.wynn.sg(F,fileres=paste(directory,"details.r",sep=dirsep),
       filematelem=paste(directory,"matelem.tmp",sep=dirsep),
       model.info,struc.info,sampl.info,init.info)
   #print(fed)
#retrieve modified data structures
   model.info<-fed$model.info;sampl.info<-fed$sampl.info
#evaluation du protocle initial
   init.fed<-fed$init.fed
   initnp<-init.fed$init.np
   data.fed<-fed$data.fed
   tab<-data.fed$tab
   opti.fed<-fed$opti.fed   
   protoc.fed<-fed$protoc.fed
   protoc<-protoc.fed$protoc;tprotoc<-protoc.fed$tprotoc
   iprote<-lapply(init.fed$init.num,function(i) protoc[[i]])
   lprote<-lapply(iprote,length)
   tprote<-lapply(init.fed$init.num,function(i) tprotoc[[i]])

#changer pour reflter les frquences initiales (ventuellement ajustes en cas de pb)
   Nbsubjects.init<-init.info$cost/sum((unlist(lprote)*init.fed$init.freq))
   subjects.init<-init.fed$init.freq*Nbsubjects.init
   call.fish<-ecofisher.meth1.final(iprote,data.fed$tab,data.fed$f.p,
   data.fed$df.p,init.fed$init.freq,model.info,init.info$cost)

   crit.init<-call.fish$crit
   #print("passe")
   print(crit.init)

   SIG<-call.fish$SIG  
   lSIG<-length(SIG[SIG!=0])

#Eco : now saves to same directory as 'control' file
   sink(paste(directory,dirsep,output,sep="")) 
   
   cat("PFIM 3.0 ",'\n',"\n")
   
   cat("Project:",project)
   cat("\n","\n") 
   cat('Date:',date()) 
   cat("\n","\n") 
   cat("\n","\n") 
 
   e<-list()
   if(modelform=="DE") {     
     for (l in 1:nr) {   
       Protocol<-c()
       for(iprot in 1:init.fed$init.np) {
         tab1<-tab[protoc[[init.fed$init.num[iprot]]],]
         Protocol<-c(Protocol,
           paste("c=(",paste(tab1$times[tab1$irep==l],collapse=", "),")",sep=""))
       }
        e[[l]]<-data.frame(Protocol,subjects=subjects.init,
          condinit=as.character(init.info$condinit))
     }
  
     cat("**************************** INPUT SUMMARY ********************************") 
     cat("\n","\n") 
     cat('Differential Equations form of the model: ','\n','\n') 
     print(struc.info$formED)
     cat("\n","\n")
     cat('Initial Population design: ','\n') 
     cat("\n","\n")
     for (i in 1:nr){
        cat('Sample times for response:',LETTERS[i],'\n')
        print(e[[i]])
        cat("\n","\n")
      }
      cat("\n","\n")
      cat('Initial Conditions at time',init.info$time.condinit,':','\n','\n')
      ff<-sapply(1:initnp, function(initnp, form) cat(paste(form[[initnp]][-1]),'\n'), form=condinit)
      cat("\n")
      cat("Error tolerance for solving differential equations system: RtolEQ =", RtolEQ,", AtolEQ =", AtolEQ,", Hmax = ",Hmax)
      cat("\n","\n")
   } else { #modelform==AF
     for (l in 1:nr) {
       Protocol<-c()
       for(iprot in 1:init.fed$init.np) {
         tab1<-tab[protoc[[init.fed$init.num[iprot]]],]
         Protocol<-c(Protocol,
           paste("c=(",paste(tab1$times[tab1$irep==l],collapse=", "),")",sep=""))
       }
        if(length(prot.dose)<length(subjects.init)) 
          prot.dose<-rep(prot.dose,length(subjects.init))
       e[[l]]<-data.frame(Protocol,subjects=subjects.init,
          doses=prot.dose[1:length(subjects.init)])
     }
     cat("**************************** INPUT SUMMARY ********************************") 
     cat("\n","\n") 
     cat('Analytical function model: ','\n','\n') 
     ff<-sapply(1:lf, function(lf, form) cat(paste(form[lf]),'\n','\n'), form=form)
     cat("\n","\n")
     cat("#########Variance error models##### \n")
     ff1<-sapply(1:nr,function(nr,sigmainter,sigmaslope) 
       cat(paste('Variance error model response',LETTERS[nr],': (',sigmainter[[nr]],'+',sigmaslope[[nr]],"*f)^2",'\n','\n')),sigmainter<-sigmainter,sigmaslope<-sigmaslope)
     cat("Between-subject variance model: Trand =",model.info$Trand)
     cat("\n","\n")  
     cat('Initial population design:','\n')
     cat("\n","\n") 
     for (i in 1:nr){
        cat('Sample times for response:',LETTERS[i],'\n')
        print(e[[i]])
        cat("\n","\n")
     }
   }
   ff1<-sapply(1:nr,function(nr,sigmainter,sigmaslope) 
   cat(paste('Variance error model response',LETTERS[nr],': (',sigmainter[[nr]],'+',sigmaslope[[nr]],"*f)^2",'\n','\n')),sigmainter<-sigmainter,sigmaslope<-sigmaslope)
   cat("\n","\n")
   cat("Between-subject variance model: Trand = ",model.info$Trand) 
   cat("\n","\n") 
   cat('Total number of samples:',init.info$cost)
   cat("\n","\n") 
   cat('Associated criterion value:',round(crit.init,4))
   cat("\n","\n\n") 
   for ( l in 1: nr) {
     cat("Sampling windows for the response:",LETTERS[l],"\n")
     for (i in 1:sampl.info$nwind[[l]]) {
        cat("Window",i,": t=",sampl.info$sampwin[[l]][[i]],"\n")
        cat("    Nb of sampling points to be taken in this window, n[",i,"]=",
          sampl.info$nsamp[[l]][[i]],"\n") }
     if(is.na(sampl.info$nmaxpts[[l]])) {
       sampl.info$nmaxpts[[l]]<-sum(unlist(lapply(sampl.info$nsamp[[l]],max)))
       cat("Computing the maximum number of points per protocol.\n")}
     cat("Maximum total number of points in one elementary protocol :",
        sampl.info$nmaxpts[[l]],"\n")
     if(is.na(sampl.info$nminpts[[l]])) {
       sampl.info$nminpts[[l]]<-sum(unlist(lapply(sampl.info$nsamp[[l]],min)))
       cat("Computing the minimum number of points per protocol.\n")}
     cat("Minimum total number of points in one elementary protocol :",
       sampl.info$nminpts[[l]],"\n")
     cat("\n","\n") 
    }
    cat("\n")
    cat("Now evaluating the Fisher Information Matrix for the",fed$yfed$y[[2]][1],"protocols generated \n")

#Now do all this for the final protocol
   iprote.f<-lapply(opti.fed$opti.num,function(i) protoc[[i]])
   lprote.f<-lapply(iprote.f,length)
   tprote.f<-lapply(opti.fed$opti.num,function(i) tprotoc[[i]])
   subjects.opti<-opti.fed$opti.freq
   num.opti<-opti.fed$opti.num
#Recover initial condition (dose or condinit) for optimised protocols
   opti.cond<-unlist(lapply(opti.fed$opti.num,
      function(inum,protoc,tab) tab$condnum[protoc[[inum]][1]],protoc=protoc,
      tab=tab))
   opti.fed$cond<-opti.cond
   subjects1<-subjects.opti*init.info$cost/sum((unlist(lprote.f)*subjects.opti))
   if(modelform=="AF") doses.opti<-prot.dose[opti.cond] else 
      condinit.opti<-condinit[opti.cond]
   fse<-ecofisher.meth1.final(iprote.f,data.fed$tab,data.fed$f.p,
   data.fed$df.p,opti.fed$opti.freq,model.info,init.info$cost)

   #print(condinit) 
   #print(fse)
   se<-fse$se;cv<-fse$cv;mfisher<-fse$somme 
   determinant<-fse$det;crit<-fse$crit;pp<-fse$pp
   StdError<-se[1:p] 
   CV<-cv[1:p] 
   Beta<-beta 
   vec<-diag(omega)!=0 
   omega1<-as.matrix(omega[,vec])[vec,]
   vec2<-SIG!=0
   
   a.row<-data.frame(Beta,StdError,CV,row.names=parameters) 
   .<-c(rep("%",p)) 
   a.row<-cbind(a.row,.) 
   Omega<-diag(as.matrix(omega1)) 
   StdError<-se[(p+1):(pp-lSIG)] 
   CV<-cv[(p+1):(pp-lSIG)] 
   b.row<-data.frame(Omega,StdError,CV,row.names=parameters[vec]) 
   .<-c(rep("%",(pp-p-lSIG))) 
   b.row<-cbind(b.row,.) 
   StdError<-se[(pp-(lSIG-1)):pp]
   CV<-cv[(pp-(lSIG-1)):pp]
   .<-rep("%",lSIG) 
   sig.names<-unlist(c(fse$xn))[SIG!=0] 
   c.row<-cbind(data.frame(SIG=SIG[SIG!=0],StdError,CV,row.names=sig.names),.)

   Subjects<-subjects1 
   f<-list()
   if(modelform=="DE")  {
#eco : vrifier si a marche aussi pour DE et si oui, enlever le test!
      for (l in 1 : nr) {
           vec<-lapply(num.opti,function(i,protoc,tab,irep) {
              tab1<-tab[protoc[[i]],]
              tab1$times[tab1$irep==irep]},protoc=protoc,tab=tab,irep=l)
           f[[l]]<-data.frame(times=as.character(vec),freq=subjects.opti,Subjects,
             condinit=as.character(condinit.opti))
      }
     } else  {
        for (l in 1:nr) {
           vec<-lapply(num.opti,function(i,protoc,tab,irep) {
              tab1<-tab[protoc[[i]],]
              tab1$times[tab1$irep==irep]},protoc=protoc,tab=tab,irep=l)
           f[[l]]<-data.frame(times=as.character(vec),freq=subjects.opti,
             Subjects,doses=doses.opti)
        }
    }
    cat("\n","\n")
    cat("**************************** OPTIMISED DESIGN *****************************") 
    cat("\n","\n") 
    cat("\n","\n") 
    cat('Optimised population design:','\n')
    for (i in 1:nr){
      cat('Sample times for response:',LETTERS[i],'\n')
      print(f[[i]])
      cat("\n","\n")
    }
    cat("\n","\n") 
    cat('Associated optimised criterion:', round(crit,4))  
    cat("\n","\n") 
    cat("\n","\n") 
    cat("******************* POPULATION FISHER INFORMATION matrix ******************") 
    cat("\n","\n") 
    print(unclass(mfisher)) 
    cat("\n","\n") 
    cat("\n","\n") 
    cat("************************** EXPECTED STANDARD ERRORS ************************") 
    cat("\n","\n") 
    cat("------------------------ Fixed Effects Parameters -------------------------") 
    cat("\n","\n") 
    print(a.row) 
    cat("\n","\n") 
    cat("------------------------- Variance of Random Effects ----------------------") 
    cat("\n","\n") 
    print(b.row) 
    cat("\n","\n") 
    cat("------------------------ Variance of residual error ------------------------") 
    cat("\n","\n") 
    print(c.row) 
    cat("\n","\n") 
    cat("******************************* DETERMINANT ********************************") 
    cat("\n","\n") 
    cat(determinant) 
    cat("\n","\n") 
    cat("******************************** CRITERION *********************************") 
    cat("\n","\n") 
    cat(crit) 
    cat("\n","\n") 
    d1<-Sys.time()
    print(d1-d) 
    g1<-proc.time()
    print(g1[2]-g[2])    
    
    sink()
    
   opti.fed$nb.subj<-subjects1
   tab<-cbind(tab,f.p=c(fed$data.fed$f.p))

   gr.list<-lapply(opti.fed$opti.num,function(j,tab,protoc) tab$irep[protoc[[j]]],tab=tab,protoc=protoc)
   gr.tps<-lapply(opti.fed$opti.num,function(j,protoc) protoc[[j]],protoc=tprotoc)
   if(graph.logical==T) {
     if(modelform=="AF") 
       graph.fw.af(gr.tps,gr.list,tab,opti.cond,graph.info,struc.info,
         model.info,init.info) else 
       graph.fw.de(gr.tps,gr.list,tab,opti.cond,graph.info,struc.info,
         model.info,init.info)
   }
   cat('OK ',"\n")    
   return(list(init.fed=fed$init.fed,data.fed=fed$data.fed,opti.fed=opti.fed,
   mfisher=mfisher,determinant=determinant,crit=crit,se=se,cv=cv))
#   return(list(init.fed=fed$init.fed,data.fed=fed$data.fed,opti.fed=opti.fed,
#      mfisher=mfisher,determinant=determinant,crit=crit,se=se,cv=cv),
#      init.info=init.info,model.info=model.info,struc.info=struc.info)
   
}

